// =============================================================================
// soubor building_a02.cpp
// =============================================================================

#include"..\buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 
static float a02_vertices[][3] = {
  -1, 0, -0.5f,  // 0
	 1, 0, -0.5f,  // 1
   1, 1, -0.5f,  // 2
  -1, 1, -0.5f,  // 3

  -1, 1.5, 0.5f,  // 4
	 1, 1.5, 0.5f,  // 5

	 1, 1, 0.5f,  // 6
  -1, 1, 0.5f,  // 7
  -1, 0, 0.5f,  // 8
   1, 0, 0.5f,  // 9
};

// NORMALS
// normaly pro dobre osvetleni sten modelu budovy
static float a02_normal[][3] = {
	 1,  0,  0, // 0 x 
   0,  1,  0, // 1 y
   0,  0,  1, // 2 z
 
	-1,  0,  0, // 3 -x
   0, -1,  0, // 4 -y
   0,  0, -1, // 5 -z

   0,0.89442f,-0.44721f  // 6 front_up sklon strechy
};

// steny z bodu
static int32_t a02_indices_front[] = { 1,0,2,3, -1 };
static int32_t a02_indices_up[] = { 2,3,5,4, -1 };
static int32_t a02_indices_left[] = { 5,2,6,1,9, -1 };
static int32_t a02_indices_right[] = { 4,3,7,0,8, -1 };
static int32_t a02_indices_back[] = { 4,5,8,9, -1 };
static int32_t a02_indices_bottom[] = { 0,1,8,9, -1 };

// normaly ke stenam
static int normalIndex_a02_front[] = { 5, 5 };
static int normalIndex_a02_up[] = { 6, 6 };
static int normalIndex_a02_left[] = { 0, 0, 0 };
static int normalIndex_a02_right[] = { 3, 3, 3 };
static int normalIndex_a02_back[] = { 2, 2 };
static int normalIndex_a02_bottom[] = { 4, 4 };

// texturovaci souradnice pro jednotlive steny
static int32_t TexCoordIndex_a02_front[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_a02_up[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_a02_left[] = { 3,4,5,0,1, -1 };
static int32_t TexCoordIndex_a02_right[] = { 3,4,5,0,1, -1 };
static int32_t TexCoordIndex_a02_back[] = { 2,3,0,1, -1 };
static int32_t TexCoordIndex_a02_bottom[] = { 0,1,2,3, -1 };


// -----------------------------------------------------------------------------
// fce.MakeBuilding_a02 - vytvori budovu a02
// -----------------------------------------------------------------------------
SoSeparator *MakeBuilding_a02(float x, float y, float z, float alfa, TEXTURE texture) {

	// uzel oznacujici budovu
	SoSeparator *a02 = new SoSeparator();
	a02 -> ref();

	// umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  a02->addChild(transform);

	// velikost modelu budovy
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  a02->addChild(scale);

  // rotace modelu budovy
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  a02 -> addChild(myRotation);

	// normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 11, a02_normal);
  a02 -> addChild(myNormals); 

	// prirazovani normal PER_FACE_INDEXED
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  a02 -> addChild(myNormalBinding);
  
	// propojeni bodu modelu budovy
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(a02_vertices)/sizeof(float), a02_vertices);
  a02->addChild(coords);

	// 'vyrez textury' (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  texCoord->point.set1Value(4, SbVec2f(0,0.6666f));
  texCoord->point.set1Value(5, SbVec2f(1,0.6666f));

  a02->addChild(texCoord);

  // front
  SoTexture2 *texture_a02 = new SoTexture2;
  a02 -> addChild(texture_a02);
	switch(texture) {
		case BRICK: texture_a02 -> filename.setValue("Texture/buildings/a02/brick/texture_a02_front.PNG"); break;
		case COLOR: texture_a02 -> filename.setValue("Texture/buildings/a02/color/texture_a02_front.PNG"); break;
		case STONE: texture_a02 -> filename.setValue("Texture/buildings/a02/stone/texture_a02_front.PNG"); break;
		case WOOD:  texture_a02 -> filename.setValue("Texture/buildings/a02/wood/texture_a02_front.PNG");  break;
	}

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(a02_indices_front)/sizeof(int32_t), a02_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_a02_front)/sizeof(int), normalIndex_a02_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_a02_front)/sizeof(int32_t), TexCoordIndex_a02_front); 
  a02->addChild(stripSet);


  // up
  texture_a02 = new SoTexture2;
  a02 -> addChild(texture_a02);
	switch(texture) {
		case BRICK: texture_a02 -> filename.setValue("Texture/buildings/a02/brick/texture_a02_up.PNG"); break;
		case COLOR: texture_a02 -> filename.setValue("Texture/buildings/a02/color/texture_a02_up.PNG"); break;
		case STONE: texture_a02 -> filename.setValue("Texture/buildings/a02/stone/texture_a02_up.PNG"); break;
		case WOOD:  texture_a02 -> filename.setValue("Texture/buildings/a02/wood/texture_a02_up.PNG");  break;
	}

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(a02_indices_up)/sizeof(int32_t), a02_indices_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_a02_up)/sizeof(int), normalIndex_a02_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_a02_up)/sizeof(int32_t), TexCoordIndex_a02_up); 
  a02->addChild(stripSet);


  // left
  texture_a02 = new SoTexture2;
  a02 -> addChild(texture_a02);
	switch(texture) {
		case BRICK: texture_a02 -> filename.setValue("Texture/buildings/a02/brick/texture_a02_left.PNG"); break;
		case COLOR: texture_a02 -> filename.setValue("Texture/buildings/a02/color/texture_a02_left.PNG"); break;
		case STONE: texture_a02 -> filename.setValue("Texture/buildings/a02/stone/texture_a02_left.PNG"); break;
		case WOOD:  texture_a02 -> filename.setValue("Texture/buildings/a02/wood/texture_a02_left.PNG");  break;
	}

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(a02_indices_left)/sizeof(int32_t), a02_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_a02_left)/sizeof(int), normalIndex_a02_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_a02_left)/sizeof(int32_t), TexCoordIndex_a02_left); 
  a02->addChild(stripSet);


  // right
  texture_a02 = new SoTexture2;
  a02 -> addChild(texture_a02);
	switch(texture) {
		case BRICK: texture_a02 -> filename.setValue("Texture/buildings/a02/brick/texture_a02_right.PNG"); break;
		case COLOR: texture_a02 -> filename.setValue("Texture/buildings/a02/color/texture_a02_right.PNG"); break;
		case STONE: texture_a02 -> filename.setValue("Texture/buildings/a02/stone/texture_a02_right.PNG"); break;
		case WOOD:  texture_a02 -> filename.setValue("Texture/buildings/a02/wood/texture_a02_right.PNG");  break;
	}

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(a02_indices_right)/sizeof(int32_t), a02_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_a02_right)/sizeof(int), normalIndex_a02_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_a02_right)/sizeof(int32_t), TexCoordIndex_a02_right); 
  a02->addChild(stripSet);

  
  // back
  texture_a02 = new SoTexture2;
  a02 -> addChild(texture_a02);
	switch(texture) {
		case BRICK: texture_a02 -> filename.setValue("Texture/buildings/a02/brick/texture_a02_back.PNG"); break;
		case COLOR: texture_a02 -> filename.setValue("Texture/buildings/a02/color/texture_a02_back.PNG"); break;
		case STONE: texture_a02 -> filename.setValue("Texture/buildings/a02/stone/texture_a02_back.PNG"); break;
		case WOOD:  texture_a02 -> filename.setValue("Texture/buildings/a02/wood/texture_a02_back.PNG");  break;
	}

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(a02_indices_back)/sizeof(int32_t), a02_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_a02_back)/sizeof(int), normalIndex_a02_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_a02_back)/sizeof(int32_t), TexCoordIndex_a02_back); 
  a02->addChild(stripSet);


  // bottom
  texture_a02 = new SoTexture2;
  a02 -> addChild(texture_a02);
  texture_a02 -> filename.setValue("texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(a02_indices_bottom)/sizeof(int32_t), a02_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_a02_bottom)/sizeof(int), normalIndex_a02_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_a02_bottom)/sizeof(int32_t), TexCoordIndex_a02_bottom); 
  a02->addChild(stripSet);
 

	a02 -> unrefNoDelete();
	return a02;
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru building_a02.cpp
// =============================================================================