// =============================================================================
// soubor building_s08.cpp
// =============================================================================

#include"..\buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 
static float s08_vertices[][3] = {
	-2, 0, -1.5f,  // 0
	 2, 0, -1.5f,  // 1
  -2, 2, -1.5f,  // 2
   2, 2, -1.5f,  // 3

	-1, 0, -0.5f,  // 4
   1, 0, -0.5f,  // 5
  -1, 2, -0.5f,  // 6
   1, 2, -0.5f,  // 7

	-2, 0,  1.5f,  // 8
	-1, 0,  1.5f,  // 9
  -2, 2,  1.5f,  // 10
  -1, 2,  1.5f,  // 11

	 1, 0,  1.5f,  // 12
   2, 0,  1.5f,  // 13
   1, 2,  1.5f,  // 14
   2, 2,  1.5f,  // 15

	-1.5f, 2.5,  1,  // 16
  -1.5f, 2.5, -1,  // 17
   1.5f, 2.5, -1,  // 18
   1.5f, 2.5,  1,  // 19
};

// NORMALS
// normaly pro dobre osvetleni sten modelu budovy
static float s08_normal[][3] = {
  	1,  0,  0, // 0 x 
    0,  1,  0, // 1 y
    0,  0,  1, // 2 z
 
	 -1,  0,  0, // 3 -x
    0, -1,  0, // 4 -y
    0,  0, -1, // 5 -z

	 0.70710f,0.70710f,0, // 6 left_up 45 sklon strechy 
	-0.70710f,0.70710f,0, // 7 right_up 45 sklon strechy 
	 0,0.70710f,0.70710f, // 8 back_up 45 sklon strechy 
	 0,0.70710f,-0.70710f,// 9 front_up 45 sklon strechy	
};

// steny z bodu
static int32_t s08_indices_front[] = {0,1,2,3, -1};
static int32_t s08_indices_left_near[] = {0,2,8,10, -1};
static int32_t s08_indices_left_far[] = {5,7,12,14, -1};
static int32_t s08_indices_right_near[] = {1,3,13,15, -1};
static int32_t s08_indices_right_far[] = {4,6,9,11, -1};
static int32_t s08_indices_back_middle[] = {4,5,6,7, -1};
static int32_t s08_indices_back_left[] = {8,9,10,11, -1};
static int32_t s08_indices_back_right[] = {12,13,14,15, -1};
static int32_t s08_indices_up_first[] = {2,3,17,18, -1};
static int32_t s08_indices_up_second[] = {6,7,17,18, -1};
static int32_t s08_indices_up_third[] = {2,10,17,16, -1};
static int32_t s08_indices_up_fourth[] = {6,11,17,16, -1};
static int32_t s08_indices_up_fifth[] = {3,15,18,19, -1};
static int32_t s08_indices_up_sixth[] = {7,14,18,19, -1};
static int32_t s08_indices_up_seventh[] = {10,11,16, -1};
static int32_t s08_indices_up_eighth[] = {14,15,19, -1};
static int32_t s08_indices_bottom[] = {8,9,0,4,1,5,13,12, -1};

// normaly ke stenam
static int normalIndex_s08_front[] = {5,5};   // -z     
static int normalIndex_s08_left_near[] = {3,3};    // -x
static int normalIndex_s08_left_far[] = {3,3};    // -x
static int normalIndex_s08_right_near[] = {0,0};   //  x
static int normalIndex_s08_right_far[] = {0,0};   //  x
static int normalIndex_s08_back_middle[] = {2,2};    //  z
static int normalIndex_s08_back_left[] = {2,2};    //  z
static int normalIndex_s08_back_right[] = {2,2};    //  z
static int normalIndex_s08_up_first[] = {9,9};      //  y  
static int normalIndex_s08_up_second[] = {8,8};      //  y 
static int normalIndex_s08_up_third[] = {7,7};      //  y 
static int normalIndex_s08_up_fourth[] = {6,6};      //  y 
static int normalIndex_s08_up_fifth[] = {6,6};      //  y 
static int normalIndex_s08_up_sixth[] = {7,7};      //  y 
static int normalIndex_s08_up_seventh[] = {8};      //  y 
static int normalIndex_s08_up_eighth[] = {8};      //  y 
static int normalIndex_s08_bottom[] = {4,4,4,4,4,4};  // -y

// texturovaci souradnice pro jednotlive steny
static int32_t TexCoordIndex_s08_front[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s08_up_first[] = {0,1,8,9, -1}; // front
static int32_t TexCoordIndex_s08_up_second[] = {10,11,2,3, -1};
static int32_t TexCoordIndex_s08_up_third[] = {0,1,12,13, -1};
static int32_t TexCoordIndex_s08_up_fourth[] = {11,0,3,12, -1};
static int32_t TexCoordIndex_s08_up_fifth[] = {0,1,12,13, -1};
static int32_t TexCoordIndex_s08_up_sixth[] = {11,0,3,12, -1};
static int32_t TexCoordIndex_s08_up_seventh[] = {0,1,14, -1};
static int32_t TexCoordIndex_s08_up_eighth[] = {0,1,14, -1};
static int32_t TexCoordIndex_s08_left_near[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s08_left_far[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s08_right_near[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s08_right_far[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s08_back_middle[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s08_back_left[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s08_back_right[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s08_bottom[] = {2,4,0,5,1,6,3,7, -1};


// -----------------------------------------------------------------------------
// fce.MakeBuilding_s08 - vytvori budovu s08
// -----------------------------------------------------------------------------
SoSeparator *MakeBuilding_s08(float x, float y, float z, float alfa, TEXTURE texture) {
  
	// uzel oznacujici budovu
  SoSeparator *s08 = new SoSeparator;
  s08 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  s08->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  s08->addChild(scale);

  // rotace modelu budovy
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  s08 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, s08_normal);
  s08 -> addChild(myNormals); 

  // prirazovani normal PER_FACE_INDEXED 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  s08 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(s08_vertices)/sizeof(float), s08_vertices);
  s08->addChild(coords);

  // 'vyrez textury' (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));

  texCoord->point.set1Value(4, SbVec2f(0.25,1));
  texCoord->point.set1Value(5, SbVec2f(0.25,0.3333f));
  texCoord->point.set1Value(6, SbVec2f(0.75,0.3333f));
  texCoord->point.set1Value(7, SbVec2f(0.75,1));

  texCoord->point.set1Value(8, SbVec2f(0.125f,1));
  texCoord->point.set1Value(9, SbVec2f(0.875f,1));

  texCoord->point.set1Value(10, SbVec2f(0.16666f,0));
  texCoord->point.set1Value(11, SbVec2f(0.83333f,0));

  texCoord->point.set1Value(12, SbVec2f(0.16666f,1));
  texCoord->point.set1Value(13, SbVec2f(0.83333f,1));

  texCoord->point.set1Value(14, SbVec2f(0.5f,1));

  s08->addChild(texCoord);

  // front
  SoTexture2 *texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_front.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_front.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_front.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_front.PNG");  break;
	}
  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_front)/sizeof(int32_t), s08_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_front)/sizeof(int), normalIndex_s08_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_front)/sizeof(int32_t), TexCoordIndex_s08_front); 
  s08->addChild(stripSet);


  // up_first
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_front.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_front.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_front.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_front.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_first)/sizeof(int32_t), s08_indices_up_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_first)/sizeof(int), normalIndex_s08_up_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_first)/sizeof(int32_t), TexCoordIndex_s08_up_first); 
  s08->addChild(stripSet);

  // up_second
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_side.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_side.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_side.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_side.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_second)/sizeof(int32_t), s08_indices_up_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_second)/sizeof(int), normalIndex_s08_up_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_second)/sizeof(int32_t), TexCoordIndex_s08_up_second); 
  s08->addChild(stripSet);

  // up_third
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_side.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_side.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_side.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_side.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_third)/sizeof(int32_t), s08_indices_up_third);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_third)/sizeof(int), normalIndex_s08_up_third);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_third)/sizeof(int32_t), TexCoordIndex_s08_up_third); 
  s08->addChild(stripSet);

  // up_fourth
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_side_in.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_side_in.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_side_in.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_side_in.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_fourth)/sizeof(int32_t), s08_indices_up_fourth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_fourth)/sizeof(int), normalIndex_s08_up_fourth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_fourth)/sizeof(int32_t), TexCoordIndex_s08_up_fourth); 
  s08->addChild(stripSet);

  // up_fifth
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_side.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_side.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_side.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_side.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_fifth)/sizeof(int32_t), s08_indices_up_fifth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_fifth)/sizeof(int), normalIndex_s08_up_fifth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_fifth)/sizeof(int32_t), TexCoordIndex_s08_up_fifth); 
  s08->addChild(stripSet);

  // up_sixth
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_side_in.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_side_in.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_side_in.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_side_in.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_sixth)/sizeof(int32_t), s08_indices_up_sixth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_sixth)/sizeof(int), normalIndex_s08_up_sixth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_sixth)/sizeof(int32_t), TexCoordIndex_s08_up_sixth); 
  s08->addChild(stripSet);

  // up_seventh
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_back.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_back.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_back.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_back.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_seventh)/sizeof(int32_t), s08_indices_up_seventh);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_seventh)/sizeof(int), normalIndex_s08_up_seventh);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_seventh)/sizeof(int32_t), TexCoordIndex_s08_up_seventh); 
  s08->addChild(stripSet);

  // up_eighth
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_up_back.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_up_back.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_up_back.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_up_back.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_up_eighth)/sizeof(int32_t), s08_indices_up_eighth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_up_eighth)/sizeof(int), normalIndex_s08_up_eighth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_up_eighth)/sizeof(int32_t), TexCoordIndex_s08_up_eighth); 
  s08->addChild(stripSet);


  // left_near
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_out.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_out.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_out.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_out.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_left_near)/sizeof(int32_t), s08_indices_left_near);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_left_near)/sizeof(int), normalIndex_s08_left_near);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_left_near)/sizeof(int32_t), TexCoordIndex_s08_left_near); 
  s08->addChild(stripSet);


  // left_far
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_in.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_in.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_in.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_in.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_left_far)/sizeof(int32_t), s08_indices_left_far);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_left_far)/sizeof(int), normalIndex_s08_left_far);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_left_far)/sizeof(int32_t), TexCoordIndex_s08_left_far); 
  s08->addChild(stripSet);


  // right_near
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_out.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_out.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_out.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_out.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_right_near)/sizeof(int32_t), s08_indices_right_near);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_right_near)/sizeof(int), normalIndex_s08_right_near);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_right_near)/sizeof(int32_t), TexCoordIndex_s08_right_near); 
  s08->addChild(stripSet);


  // right_far
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_in.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_in.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_in.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_in.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_right_far)/sizeof(int32_t), s08_indices_right_far);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_right_far)/sizeof(int), normalIndex_s08_right_far);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_right_far)/sizeof(int32_t), TexCoordIndex_s08_right_far); 
  s08->addChild(stripSet);
  
  // back_middle
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_in_back.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_in_back.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_in_back.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_in_back.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_back_middle)/sizeof(int32_t), s08_indices_back_middle);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_back_middle)/sizeof(int), normalIndex_s08_back_middle);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_back_middle)/sizeof(int32_t), TexCoordIndex_s08_back_middle); 
  s08->addChild(stripSet);


  // back_left
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_back.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_back.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_back.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_back.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_back_left)/sizeof(int32_t), s08_indices_back_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_back_left)/sizeof(int), normalIndex_s08_back_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_back_left)/sizeof(int32_t), TexCoordIndex_s08_back_left); 
  s08->addChild(stripSet);


  // back_right
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
	switch(texture) {
		case BRICK: texture_s08 -> filename.setValue("Texture/buildings/s08/brick/texture_s08_back.PNG"); break;
		case COLOR: texture_s08 -> filename.setValue("Texture/buildings/s08/color/texture_s08_back.PNG"); break;
		case STONE: texture_s08 -> filename.setValue("Texture/buildings/s08/stone/texture_s08_back.PNG"); break;
		case WOOD:  texture_s08 -> filename.setValue("Texture/buildings/s08/wood/texture_s08_back.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_back_right)/sizeof(int32_t), s08_indices_back_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_back_right)/sizeof(int), normalIndex_s08_back_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_back_right)/sizeof(int32_t), TexCoordIndex_s08_back_right); 
  s08->addChild(stripSet);


  // bottom
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_bottom)/sizeof(int32_t), s08_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_bottom)/sizeof(int), normalIndex_s08_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_bottom)/sizeof(int32_t), TexCoordIndex_s08_bottom); 
  s08->addChild(stripSet);

  s08 -> unrefNoDelete();

  return s08;
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru building_s08.cpp
// =============================================================================