// =============================================================================
// soubor building_s09.cpp
// =============================================================================

#include"..\buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 
static float s09_vertices[][3] = {
	-2, 0, -2,  // 0
	 2, 0, -2,  // 1
  -2, 2, -2,  // 2
   2, 2, -2,  // 3

	-1, 0, -1,  // 4
   1, 0, -1,  // 5
  -1, 2, -1,  // 6
   1, 2, -1,  // 7

	-1, 0,  1,  // 8
	 1, 0,  1,  // 9
  -1, 2,  1,  // 10
   1, 2,  1,  // 11

	-2, 0,  2,  // 12
   2, 0,  2,  // 13
  -2, 2,  2,  // 14
   2, 2,  2,  // 15

	-1.5f, 2.5, -1.5f,  // 16
   1.5f, 2.5, -1.5f,  // 17
  -1.5f, 2.5,  1.5f,  // 18
   1.5f, 2.5,  1.5f,  // 19
};

// NORMALS
// normaly pro dobre osvetleni sten modelu budovy
static float s09_normal[][3] = {
  	1,  0,  0, // 0 x 
    0,  1,  0, // 1 y
    0,  0,  1, // 2 z
 
	 -1,  0,  0, // 3 -x
    0, -1,  0, // 4 -y
    0,  0, -1, // 5 -z

	 0.70710f,0.70710f,0, // 6 left_up 45 sklon strechy 
	-0.70710f,0.70710f,0, // 7 right_up 45 sklon strechy 
	 0,0.70710f,0.70710f, // 8 back_up 45 sklon strechy 
	 0,0.70710f,-0.70710f,// 9 front_up 45 sklon strechy	
};

// steny z bodu
static int32_t s09_indices_front_near[] = {0,1,2,3, -1};
static int32_t s09_indices_front_far[] = {8,9,10,11, -1};
static int32_t s09_indices_back_near[] = {4,5,6,7, -1};
static int32_t s09_indices_back_far[] = {12,13,14,15, -1};
static int32_t s09_indices_left_near[] = {0,2,12,14, -1};
static int32_t s09_indices_left_far[] = {5,7,9,11, -1};
static int32_t s09_indices_right_near[] = {1,3,13,15, -1};
static int32_t s09_indices_right_far[] = {4,6,8,10, -1};
static int32_t s09_indices_up_first[] = {2,3,16,17, -1};
static int32_t s09_indices_up_second[] = {6,7,16,17, -1};
static int32_t s09_indices_up_third[] = {2,14,16,18, -1};
static int32_t s09_indices_up_fourth[] = {6,10,16,18, -1};
static int32_t s09_indices_up_fifth[] = {3,15,17,19, -1};
static int32_t s09_indices_up_sixth[] = {7,11,17,19, -1};
static int32_t s09_indices_up_seventh[] = {10,11,18,19, -1};
static int32_t s09_indices_up_eighth[] = {14,15,18,19, -1};
static int32_t s09_indices_bottom[] = {0,4,1,5,13,9,12,8,0,4, -1};

// normaly ke stenam
static int normalIndex_s09_front_near[] = {5,5};   // -z  
static int normalIndex_s09_front_far[] = {5,5};   // -z    
static int normalIndex_s09_left_near[] = {3,3};    // -x
static int normalIndex_s09_left_far[] = {3,3};    // -x
static int normalIndex_s09_right_near[] = {0,0};   //  x
static int normalIndex_s09_right_far[] = {0,0};   //  x
static int normalIndex_s09_back_near[] = {2,2};    //  z
static int normalIndex_s09_back_far[] = {2,2};    //  z
static int normalIndex_s09_up_first[] = {9,9};      //  y  
static int normalIndex_s09_up_second[] = {8,8};      //  y 
static int normalIndex_s09_up_third[] = {7,7};      //  y 
static int normalIndex_s09_up_fourth[] = {6,6};      //  y 
static int normalIndex_s09_up_fifth[] = {6,6};      //  y 
static int normalIndex_s09_up_sixth[] = {7,7};      //  y 
static int normalIndex_s09_up_seventh[] = {9,9};      //  y 
static int normalIndex_s09_up_eighth[] = {8,8};      //  y 
static int normalIndex_s09_bottom[] = {4,4,4,4,4,4,4,4};  // -y

// texturovaci souradnice pro jednotlive steny
static int32_t TexCoordIndex_s09_front_near[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s09_front_far[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s09_up_first[] = {0,1,8,9, -1};
static int32_t TexCoordIndex_s09_up_second[] = {10,11,2,3, -1};
static int32_t TexCoordIndex_s09_up_third[] = {0,1,8,9, -1};
static int32_t TexCoordIndex_s09_up_fourth[] = {10,11,2,3, -1};
static int32_t TexCoordIndex_s09_up_fifth[] = {0,1,8,9, -1};
static int32_t TexCoordIndex_s09_up_sixth[] = {10,11,2,3, -1};
static int32_t TexCoordIndex_s09_up_seventh[] = {10,11,2,3, -1}; // 
static int32_t TexCoordIndex_s09_up_eighth[] = {0,1,8,9, -1};
static int32_t TexCoordIndex_s09_left_near[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s09_left_far[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s09_right_near[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s09_right_far[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_s09_back_near[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s09_back_far[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_s09_bottom[] = {0,4,1,5,3,7,2,6,0,4, -1};


// -----------------------------------------------------------------------------
// fce.MakeBuilding_s09 - vytvori budovu s09
// -----------------------------------------------------------------------------
SoSeparator *MakeBuilding_s09(float x, float y, float z, float alfa, TEXTURE texture) {
  
	// uzel oznacujici budovu
  SoSeparator *s09 = new SoSeparator;
  s09 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  s09->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  s09->addChild(scale);

  // rotace modelu budovy
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  s09 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, s09_normal);
  s09 -> addChild(myNormals); 

  // prirazovani normal PER_FACE_INDEXED 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  s09 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(s09_vertices)/sizeof(float), s09_vertices);
  s09->addChild(coords);

  // 'vyrez textury' (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));

  texCoord->point.set1Value(4, SbVec2f(0.25,0.25));
  texCoord->point.set1Value(5, SbVec2f(0.75,0.25));
  texCoord->point.set1Value(6, SbVec2f(0.25,0.75));
  texCoord->point.set1Value(7, SbVec2f(0.75,0.75));

  texCoord->point.set1Value(8, SbVec2f(0.125f,1));
  texCoord->point.set1Value(9, SbVec2f(0.875f,1));

  texCoord->point.set1Value(10, SbVec2f(0.16666f,0));
  texCoord->point.set1Value(11, SbVec2f(0.83333f,0));

  texCoord->point.set1Value(12, SbVec2f(0.16666f,1));
  texCoord->point.set1Value(13, SbVec2f(0.83333f,1));

  s09->addChild(texCoord);

  // front_outer
  SoTexture2 *texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_front_outer.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_front_outer.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_front_outer.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_front_outer.PNG");  break;
	}
  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_front_near)/sizeof(int32_t), s09_indices_front_near);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_front_near)/sizeof(int), normalIndex_s09_front_near);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_front_near)/sizeof(int32_t), TexCoordIndex_s09_front_near); 
  s09->addChild(stripSet);

  // front_inner
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_inner.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_inner.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_inner.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_inner.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_front_far)/sizeof(int32_t), s09_indices_front_far);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_front_far)/sizeof(int), normalIndex_s09_front_far);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_front_far)/sizeof(int32_t), TexCoordIndex_s09_front_far); 
  s09->addChild(stripSet);


  // up_first
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_first)/sizeof(int32_t), s09_indices_up_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_first)/sizeof(int), normalIndex_s09_up_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_first)/sizeof(int32_t), TexCoordIndex_s09_up_first); 
  s09->addChild(stripSet);

  // up_second
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_second)/sizeof(int32_t), s09_indices_up_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_second)/sizeof(int), normalIndex_s09_up_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_second)/sizeof(int32_t), TexCoordIndex_s09_up_second); 
  s09->addChild(stripSet);

  // up_third
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_third)/sizeof(int32_t), s09_indices_up_third);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_third)/sizeof(int), normalIndex_s09_up_third);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_third)/sizeof(int32_t), TexCoordIndex_s09_up_third); 
  s09->addChild(stripSet);

  // up_fourth
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_fourth)/sizeof(int32_t), s09_indices_up_fourth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_fourth)/sizeof(int), normalIndex_s09_up_fourth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_fourth)/sizeof(int32_t), TexCoordIndex_s09_up_fourth); 
  s09->addChild(stripSet);

  // up_fifth
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_fifth)/sizeof(int32_t), s09_indices_up_fifth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_fifth)/sizeof(int), normalIndex_s09_up_fifth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_fifth)/sizeof(int32_t), TexCoordIndex_s09_up_fifth); 
  s09->addChild(stripSet);

  // up_sixth
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_sixth)/sizeof(int32_t), s09_indices_up_sixth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_sixth)/sizeof(int), normalIndex_s09_up_sixth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_sixth)/sizeof(int32_t), TexCoordIndex_s09_up_sixth); 
  s09->addChild(stripSet);

  // up_seventh
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_seventh)/sizeof(int32_t), s09_indices_up_seventh);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_seventh)/sizeof(int), normalIndex_s09_up_seventh);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_seventh)/sizeof(int32_t), TexCoordIndex_s09_up_seventh); 
  s09->addChild(stripSet);

  // up_eighth
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_up.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_up.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_up.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_up.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_up_eighth)/sizeof(int32_t), s09_indices_up_eighth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_up_eighth)/sizeof(int), normalIndex_s09_up_eighth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_up_eighth)/sizeof(int32_t), TexCoordIndex_s09_up_eighth); 
  s09->addChild(stripSet);


  // left_outer
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_outer.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_outer.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_outer.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_outer.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_left_near)/sizeof(int32_t), s09_indices_left_near);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_left_near)/sizeof(int), normalIndex_s09_left_near);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_left_near)/sizeof(int32_t), TexCoordIndex_s09_left_near); 
  s09->addChild(stripSet);


  // left_inner
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_inner.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_inner.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_inner.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_inner.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_left_far)/sizeof(int32_t), s09_indices_left_far);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_left_far)/sizeof(int), normalIndex_s09_left_far);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_left_far)/sizeof(int32_t), TexCoordIndex_s09_left_far); 
  s09->addChild(stripSet);


  // right_outer
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_outer.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_outer.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_outer.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_outer.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_right_near)/sizeof(int32_t), s09_indices_right_near);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_right_near)/sizeof(int), normalIndex_s09_right_near);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_right_near)/sizeof(int32_t), TexCoordIndex_s09_right_near); 
  s09->addChild(stripSet);


  // right_inner
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_inner.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_inner.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_inner.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_inner.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_right_far)/sizeof(int32_t), s09_indices_right_far);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_right_far)/sizeof(int), normalIndex_s09_right_far);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_right_far)/sizeof(int32_t), TexCoordIndex_s09_right_far); 
  s09->addChild(stripSet);
  

  // back_outer
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_inner.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_inner.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_inner.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_inner.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_back_near)/sizeof(int32_t), s09_indices_back_near);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_back_near)/sizeof(int), normalIndex_s09_back_near);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_back_near)/sizeof(int32_t), TexCoordIndex_s09_back_near); 
  s09->addChild(stripSet);


  // back_inner
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
	switch(texture) {
		case BRICK: texture_s09 -> filename.setValue("Texture/buildings/s09/brick/texture_s09_outer.PNG"); break;
		case COLOR: texture_s09 -> filename.setValue("Texture/buildings/s09/color/texture_s09_outer.PNG"); break;
		case STONE: texture_s09 -> filename.setValue("Texture/buildings/s09/stone/texture_s09_outer.PNG"); break;
		case WOOD:  texture_s09 -> filename.setValue("Texture/buildings/s09/wood/texture_s09_outer.PNG");  break;
	}
  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_back_far)/sizeof(int32_t), s09_indices_back_far);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_back_far)/sizeof(int), normalIndex_s09_back_far);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_back_far)/sizeof(int32_t), TexCoordIndex_s09_back_far); 
  s09->addChild(stripSet);


  // bottom
  texture_s09 = new SoTexture2;
  s09 -> addChild(texture_s09);
  texture_s09 -> filename.setValue("texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s09_indices_bottom)/sizeof(int32_t), s09_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s09_bottom)/sizeof(int), normalIndex_s09_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s09_bottom)/sizeof(int32_t), TexCoordIndex_s09_bottom); 
  s09->addChild(stripSet);

  s09 -> unrefNoDelete();

  return s09;
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru building_s09.cpp
// =============================================================================