// =============================================================================
// soubor buildings.cpp
// =============================================================================

#include"buildings.h"

// -----------------------------------------------------------------------------
// fce.SwitchBuildTexture - vraci pozadovanou texturu budovy
// -----------------------------------------------------------------------------
TEXTURE SwitchBuildTexture(int i) {
	TEXTURE TextureB;
  switch(i) {
	  case 0: TextureB = BRICK; break;
		case 1: TextureB = COLOR; break;
		case 2: TextureB = STONE; break;
		case 3: TextureB = WOOD; break;
	}
	return TextureB;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.GetParamBuilding - vraci pozadovany parametr budovy,podle xyz
// xyz = 1 -> x - 'sirka' budovy
// xyz = 2 -> z - 'delka' budovy
// xyz = 0 -> y -  vyska  budovy
// ----------------------------------------------------------------------------- 
float GetParamBuilding(int IPb,int xyz) {
  float x,y,z;
  switch(IPb) {

	// jednoduche budovy s plochou strechou
	case 0: x = 0.5f; y = 1; z = 0.5f; break;
  case 1: x = 1.0f; y = 1; z = 0.5f; break;
  case 2: x = 1.5f; y = 1; z = 0.5f; break;
  case 3: x = 2.0f; y = 1; z = 0.5f; break;
	case 4: x = 0.5f; y = 2; z = 0.5f; break;
	case 5: x = 0.5f; y = 3; z = 0.5f; break;
	case 6: x = 0.5f; y = 4; z = 0.5f; break;
  case 7: x = 1.0f; y = 2; z = 0.5f; break;
	case 8: x = 1.0f; y = 3; z = 0.5f; break;
	case 9: x = 1.0f; y = 4; z = 0.5f; break;

	// slozitejsi budovy s plochou strechou 
	case 10: x = 1.5f; y = 2; z = 1.f; break;
	case 11: x = 2.5f; y = 3; z = 1.f; break;
	case 12: x = 2.f;  y = 2; z = 1.5f; break;
	case 13: x = 2.f;  y = 2; z = 2.5f; break;

  // jednoduche budovy se sedlovou strechou
  case 14: x = 0.5f; y = 1.5f; z = 0.5f; break;
	case 15: x = 0.5f; y = 1.5f; z = 1.f; break;
	case 16: x = 0.5f; y = 1.5f; z = 1.5f; break;
  case 17: x = 0.5f; y = 1.5f; z = 2.f; break;
	case 18: x = 0.5f; y = 2.5f; z = 1.f; break;
	case 19: x = 0.5f; y = 2.5f; z = 1.5f; break;
	case 20: x = 0.5f; y = 2.5f; z = 2.f; break;

	// slozitejsi budovy se sedlovou strechou
  case 21: x = 1.5f; y = 2.5f; z = 1.f; break;
	case 22: x = 2.f;  y = 2.5f; z = 1.5f; break;
	case 23: x = 2.f;  y = 2.5f; z = 2.f; break;
		
	// jednoduche budovy s hranolovou strechou
	case 24: x = 0.5f; y = 1.5f; z = 0.5f; break; 
	case 25: x = 0.5f; y = 2.5f; z = 0.5f; break;
	case 26: x = 0.5f; y = 3.5f; z = 0.5f; break;
	case 27: x = 0.5f; y = 4.5f; z = 0.5f; break;
	
  // jednoduche budovy se sikmou strechou
	case 28: x = 0.5f; y = 1.5f; z = 0.5f; break;		
  case 29: x = 1.f;  y = 1.5f; z = 0.5f; break;
  case 30: x = 1.5f; y = 1.5f; z = 0.5f; break;
	case 31: x = 2.f;  y = 1.5f; z = 0.5f; break;
	case 32: x = 1.f;  y = 2.5f; z = 0.5f; break;
	case 33: x = 1.5f; y = 2.5f; z = 0.5f; break;
	case 34: x = 2.f;  y = 2.5f; z = 0.5f; break;

  }

	// co se ma vratit (jakej parametr sme chteli znat)
  // 1->x 2->z 
  if(xyz==1) return x;
  else if(xyz==2) return z;
  // jinak y->0
  return y;
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru buildings.cpp
// =============================================================================








