// =============================================================================
// soubor buildings.h
// =============================================================================

#ifndef buildings_h
#define buildings_h

#include <string.h>

#include<Inventor/nodes/SoCoordinate3.h>
#include<Inventor/nodes/SoSeparator.h>
#include<Inventor/nodes/SoNormal.h>
#include<Inventor/nodes/SoNormalBinding.h>
#include<Inventor/nodes/SoMaterial.h>
#include<Inventor/nodes/SoIndexedFaceSet.h>
#include<Inventor/nodes/SoFaceSet.h>
#include<Inventor/nodes/SoTransform.h>
#include<Inventor/nodes/SoScale.h>
#include<Inventor/nodes/SoTexture2.h>
#include<Inventor/nodes/SoTextureCoordinateDefault.h>
#include<Inventor/nodes/SoTextureCoordinate2.h>
#include<Inventor/nodes/SoTextureCoordinateBinding.h>
#include<Inventor/nodes/SoIndexedTriangleStripSet.h> 
#include<Inventor/nodes/SoRotationXYZ.h>

// zoom
#define SCALE_X 1.f
#define SCALE_Y 1.f
#define SCALE_Z 1.f

// typ strechy plocha,sedlova,pyramidova(stanova),sikma(pultova)
typedef enum {FLAT,SADDLE,PYRAMID,AISLE} ROOF; 

// typ textury cihla,barva,kamen,drevo
typedef enum {BRICK,COLOR,STONE,WOOD} TEXTURE; 

// prepinani na pozadovanou texturu
TEXTURE SwitchBuildTexture(int i);

// fce.na zjistovani rozmeru budovy(velikosti)
float GetParamBuilding(int IPb,int xyz);


// fce.vytvari pozadovanou budovu 
// na pozici x,y,z ; s pootocenim alfa ; a s texturou Texture

// budovy s plochou strechou
SoSeparator* MakeBuilding_f00(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f01(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f02(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f03(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f04(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f05(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f06(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f07(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f08(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f09(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f10(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f11(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f12(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_f13(float x, float y, float z, float alfa, TEXTURE Texture);

// budovy se sedlovou strechou
SoSeparator* MakeBuilding_s00(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s01(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s02(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s03(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s04(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s05(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s06(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s07(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s08(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_s09(float x, float y, float z, float alfa, TEXTURE Texture);

// budovy s pyramidovou(stanovou) strechou
SoSeparator* MakeBuilding_p01(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_p02(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_p03(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_p04(float x, float y, float z, float alfa, TEXTURE Texture);

// budovy se sikmou(pultovou) strechou
SoSeparator* MakeBuilding_a01(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_a02(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_a03(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_a04(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_a05(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_a06(float x, float y, float z, float alfa, TEXTURE Texture);
SoSeparator* MakeBuilding_a07(float x, float y, float z, float alfa, TEXTURE Texture);

#endif

// =============================================================================
// konec souboru buildings.h
// =============================================================================