// =============================================================================
// soubor Main-Windows.cpp
// =============================================================================

// -----------------------------------------------------------------------------
// THIS SOFTWARE IS NOT COPYRIGHTED EXCEPT FaultFormatin2,SoScreenPositioner
// lisence of FaultFormatin2 you can find on
// http://www.root.cz/clanky/open-inventor-terrain-generator-2/
// lisence of SoScreenPositioner you can find in file
// written by PCJohn (peciva _at fit.vutbr.cz)
//
// This source code is offered for use in the public domain.
// You may use, modify or distribute it freely.
//
// This source code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED.  This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// If you find the source code useful, authors will kindly welcome
// if you give them credit and keep their names with their source code,
// but do not feel to be forced to do so.
// -----------------------------------------------------------------------------

#include "Main-Windows.h"

// -----------------------------------------------------------------------------
// pomocna fce.prevod char na int podle ordinalni hodnoty v ASCII
// -----------------------------------------------------------------------------
int char_to_int(int c) {
  int i;
  switch(c) {
    case 48: i = 0; break;
    case 49: i = 1; break;
    case 50: i = 2; break;
    case 51: i = 3; break;
    case 52: i = 4; break;
    case 53: i = 5; break;
    case 54: i = 6; break;
    case 55: i = 7; break;
    case 56: i = 8; break;
    case 57: i = 9; break;
  }
	return(i);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// prevodni fce. stupne na radiany
// -----------------------------------------------------------------------------
float deg_to_rad (float x) {
  const double PI = 3.1415;
  return (float) (PI/180)*x; 
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vypis textu u BuildViewru
// -----------------------------------------------------------------------------
void BuildViewerText() {
  printf("\n\t Pripravuji prohlizec budov.\n\n");
	printf("\n  OVLADACI KLAVESY: \n");
	printf("\n  Pohyb po jednotlivych modelech budov vcetne textur ");
	printf("\n  '>'mensitko '.'tecka  nebo ' 'Mezernik ....... dopredu, NEXT ");
	printf("\n  '<'mensitko ','tecka .......................... dozadu, BACK ");
	printf("\n");
	printf("\n  Page up/down ......... posun po jednotlivych tvarech budov");
	printf("\n");
	printf("\n  1, 2, 3, 4 ... zobrazi danou budovu s prislusnou texturou");
	printf("\n");
	printf("\n    1  -  Brick, cihlova fasada ");
	printf("\n    2  -  Color, barevna fasada ");
	printf("\n    3  -  Stone, kamenna fasada ");
	printf("\n    4  -  Wood,  drevena fasada ");
	printf("\n");
	printf("\n  F1, F2, F3, F4 ....... zobrazi prvni budovu s prislusnou strechou");
	printf("\n");
	printf("\n    F1  -  Flat roof,    plocha, rovna strecha ");
	printf("\n    F2  -  Saddle roof,  sedlova, stitova strecha ");
	printf("\n    F3  -  Pyramid roof, pyramidova, stanova strecha ");
	printf("\n    F4  -  Aisle roof,   sikma, pultova strecha ");
	printf("\n\n");
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vypis textu u TownTerrainVieweru
// -----------------------------------------------------------------------------
void TownTerrainViewerText() {
  printf("\n\t Generuji virtualni mestskou zastavbu na celnity teren. \n");
	printf("\n  OVLADACI KLAVESY: \n");
  printf("\n  Mezernik ....... opetovne generovani virtualni mestske zastavby ");
	printf("\n\n");
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vypis textu u TownStructureVieweru
// -----------------------------------------------------------------------------
void TownStructureViewerText() {
	printf("\n\t Pripravuji prohlizec struktur mesta.\n");
	printf("\n  OVLADACI KLAVESY: \n");
	printf("\n  Pohyb po jednotlivych mestskych strukturach ");
	printf("\n  '>'mensitko '.'tecka  nebo ' 'Mezernik ....... dopredu, NEXT ");
	printf("\n  '<'mensitko ','tecka .......................... dozadu, BACK ");
	printf("\n");
	printf("\n  F1, F2, F3, F4 ....... zobrazi prvni mestskou strukturu daneho typu");
	printf("\n");
	printf("\n    F1  -  Centre,   centrum ");
	printf("\n    F2  -  District, ctvrt ");
	printf("\n    F3  -  Square,   namesti ");
	printf("\n    F4  -  Suburb,   predmesti ");
	printf("\n\n");
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vypis textu u TownFlatVieweru
// -----------------------------------------------------------------------------
void TownFlatViewerText() {
	printf("\n\t Generuji virtualni mestskou zastavbu na plochu s komunikacemi. \n");
	printf("\n  OVLADACI KLAVESY: \n");
	printf("\n  Mezernik ....... opetovne generovani virtualni mestske zastavby ");
	printf("\n\n");
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.main_BuildViewer - prohlizec budov 
// -----------------------------------------------------------------------------
void main_BuildViewer(int argc, char **argv, SoSeparator *root) {

	BuildViewerText();

	float alfa = 0;

  // rotace modelu podle X
	alfa = deg_to_rad(30);
  SoRotationXYZ *myRotationX = new SoRotationXYZ;
  myRotationX -> angle = alfa;
  myRotationX -> axis = SoRotationXYZ::X;
  root -> addChild(myRotationX);

	// Na koren sceny(root) pripoj dalsi uzel sceny(Buildings)
  SoSeparator *Buildings = new SoSeparator();
  root->addChild(Buildings);		
  Buildings->addChild(CreateBuild(argc, argv));

  // Obsluha klavesnice - cbBuildings pres fce.BuildEventCB 
  SoEventCallback *cbBuildings = new SoEventCallback;
  cbBuildings->addEventCallback(SoKeyboardEvent::getClassTypeId(), BuildEventCB, Buildings);
  root->insertChild(cbBuildings, 0);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.main_Generator - generovani mesta v krajine 3D (jen budovy)
// -----------------------------------------------------------------------------
void main_Generator(int argc, char **argv, SoSeparator *root) {

	TownTerrainViewerText();

	float alfa = 0;

  // rotace modelu podle X
	alfa = deg_to_rad(45);
  SoRotationXYZ *myRotationX = new SoRotationXYZ;
  myRotationX -> angle = alfa;
  myRotationX -> axis = SoRotationXYZ::X;
  root -> addChild(myRotationX);

  // rotace modelu podle Y
	alfa = deg_to_rad(10);
  SoRotationXYZ *myRotationY = new SoRotationXYZ;
  myRotationY -> angle = alfa;
  myRotationY -> axis = SoRotationXYZ::Y;
  root -> addChild(myRotationY);

	// Na koren sceny(root) pripoj dalsi uzel sceny(Town3D)
  SoSeparator *Town3D = new SoSeparator();
  root->addChild(Town3D);
  Town3D->addChild(CreateGener(argc, argv));

  // Obsluha klavesnice - cbTown3D pres fce.Town3DEventCB
  SoEventCallback *cbTown3D = new SoEventCallback;
  cbTown3D->addEventCallback(SoKeyboardEvent::getClassTypeId(), TownTerrainEventCB, Town3D);
  root->insertChild(cbTown3D, 0);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.main_TownStructureViewer - prohlizec struktur mesta
// -----------------------------------------------------------------------------
void main_TownStructureViewer(int argc, char **argv, SoSeparator *root) {

	TownStructureViewerText();

	float alfa = 0;

  // rotace modelu podle X
	alfa = deg_to_rad(45);
  SoRotationXYZ *myRotationX = new SoRotationXYZ;
  myRotationX -> angle = alfa;
  myRotationX -> axis = SoRotationXYZ::X;
  root -> addChild(myRotationX);

  // rotace modelu podle Y
	alfa = deg_to_rad(10);
  SoRotationXYZ *myRotationY = new SoRotationXYZ;
  myRotationY -> angle = alfa;
  myRotationY -> axis = SoRotationXYZ::Y;
  root -> addChild(myRotationY);

	// Na koren sceny(root) pripoj dalsi uzel sceny(TownStructures)
  SoSeparator *TownStructures = new SoSeparator();
  root->addChild(TownStructures);
  TownStructures->addChild(CreateStructures(argc, argv));

  // Obsluha klavesnice - cbStructures pres fce.StuctEventCB
  SoEventCallback *cbStructures = new SoEventCallback;
  cbStructures->addEventCallback(SoKeyboardEvent::getClassTypeId(), StructEventCB, TownStructures);
  root->insertChild(cbStructures, 0);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.main_TownGenerator - generuje mesto na plochu 2D (budovy+cesty)
// -----------------------------------------------------------------------------
void main_TownGenerator(int argc, char **argv, SoSeparator *root) {

	TownFlatViewerText();

	float alfa = 0;

  // rotace modelu podle X
	alfa = deg_to_rad(45);
  SoRotationXYZ *myRotationX = new SoRotationXYZ;
  myRotationX -> angle = alfa;
  myRotationX -> axis = SoRotationXYZ::X;
  root -> addChild(myRotationX);

  // rotace modelu podle Y
	alfa = deg_to_rad(10);
  SoRotationXYZ *myRotationY = new SoRotationXYZ;
  myRotationY -> angle = alfa;
  myRotationY -> axis = SoRotationXYZ::Y;
  root -> addChild(myRotationY);

	// Na koren sceny(root) pripoj dalsi uzel sceny(Town2D)
  SoSeparator *Town2D = new SoSeparator();
  root->addChild(Town2D);
  Town2D->addChild(CreateGenTownFlat(argc, argv));

  // Obsluha klavesnice - cbTown2D pres fce.Town2DEventCB
  SoEventCallback *cbTown2D = new SoEventCallback;
  cbTown2D->addEventCallback(SoKeyboardEvent::getClassTypeId(), TownFlatEventCB, Town2D);
  root->insertChild(cbTown2D, 0);
}
// -----------------------------------------------------------------------------



// -----------------------------------------------------------------------------
// --- MAIN ---
// -----------------------------------------------------------------------------
int main(int argc, char **argv)
{
  // Inicializuj Inventor
  HWND window = SoWin::init(argv[0]);
  if (window == NULL) exit(1);

  int c = 0;
  int i = 0;
  while(c==0) {
		printf("\n"); printf("\n");
		printf("\t\tGenerovani virtualni mestske zastavby.\n\n");
		printf("\n");
		printf("\tDiplomovy projekt DPI - 2005/2006:\n\n");
    printf("\t\tProhlizeni budov mestske zastavby..................1\n");
    printf("\t\tGenerovani mesta 3D bez komunikaci.................2\n");
		printf("\t\tProhlizeni struktur mestske zastavby ..............3\n");
    printf("\t\tGenerovani mesta 2D s komunikacemi.................4\n");
		printf("\n");
    printf("\tVase volba: ");
    c = getchar();
	if(!(isdigit(c))) {
	  printf("\n\tSpatna volba:");
	  printf("\n\tZadana hodnota neni cislo zkontrolujte nastaveni klavesnice Cz/En.\n");
	  c = getchar(); // ENTER mi to bere 
 	  c = 0;
	} // end if
    else {
			i = char_to_int(c);
			if(i<1 || i>5) {
				printf("\n\tSpatna volba:");
				printf("\n\tZadana hodnota je mimo rozsah nabidky.\n");	
 				c = 0;
			} // end if
		} // end else
  } // end while


	// Vytvo koen scny
	SoSeparator *root = new SoSeparator;
	root->ref();

	// Pro prepinani prohlizecu
	SoSeparator *rootCB = new SoSeparator;
	root->addChild(rootCB);

	// camera
  SoPerspectiveCamera *camera = new SoPerspectiveCamera;
  rootCB->addChild(camera);

	switch(i) {
		case 1: main_BuildViewer(argc,argv,rootCB); break;
		case 2: main_Generator(argc,argv,rootCB); break;
		case 3: main_TownStructureViewer(argc,argv,rootCB); break;
		case 4: main_TownGenerator(argc,argv,rootCB); break;
	} // end switch


	// Vytvori okno prohlizece 
	// SoMyExaminerViewer upraven pro ovladaci klavesy
	viewer = new SoMyExaminerViewer(window);

  // camera setup
  camera->orientation.setValue(camera->orientation.getValue() * SbRotation(SbVec3f(1.f,0.f,0.f), float(M_PI)/8.f));
  camera->viewAll(rootCB, viewer->getViewportRegion());

  // positioned scene will be drawn without zbuffer
  SoAnnotation *posRoot = new SoAnnotation;
  rootCB->addChild(posRoot);

  // window centre: scene positioner
  SoScreenPositioner::initClass();
  SoScreenPositioner *position1 = new SoScreenPositioner;
  position1->screenOrigin.setValue(0.f,1.f);
  position1->screenPosition.setValue(20,-10);
  posRoot->addChild(position1);

  // window centre: black material
  SoMaterial *mat = new SoMaterial;
  mat->diffuseColor.setValue(0.6f,0.6f,0.6f);
  posRoot->addChild(mat);

  // Vytvoreni fontu a jeho velikost
	SoFont *myFont = new SoFont;
  myFont->name.setValue("Arial");
  myFont->size.setValue(13);
  posRoot->addChild(myFont); 

	// window centre: text
  SoText2 *text = new SoText2;

	switch(i) {
		case 1: 
			viewer->setTitle("- Buildings Viewer -");
			text->string.set1Value(0, "");
			text->string.set1Value(1, "Posun po jednotlivych budovach:   '  ' nebo '>' / '<'    Dopredu/Dozadu");
			text->string.set1Value(2, " - podle tvaru budovy: PAGE_UP / PAGE_DOWN    Dopredu/Dozadu");
			text->string.set1Value(3, " - podle strechy budovy:");
			text->string.set1Value(4, "  F1 - Plocha, F2 - Sedlova, F3 - Pyramidova, F4 - Pultova");
			text->string.set1Value(5, "Prepinani textur budovy: ");
			text->string.set1Value(6, "  1 - Cihlova, 2 - Barevna, 3 - Kamenna, 4 - Drevena");
			text->string.set1Value(7, "");
		break;
		case 2: 
			viewer->setTitle("- Virtualni town development on landscape Fault Formation 2 -"); 
			text->string.set1Value(0, "");
			text->string.set1Value(1, "");
			text->string.set1Value(2, "Nove generovani mestske zastavby:   '  '  mezernik.");
			text->string.set1Value(3, "");
		break;
		case 3: 
			viewer->setTitle("- Town Structure Viewer -"); 
			text->string.set1Value(0, "");
			text->string.set1Value(1, "Posun po jednotlivych strukturach:   '  ' nebo '>' / '<'    Dopredu/Dozadu");
			text->string.set1Value(2, " ");
			text->string.set1Value(3, "Posun na mestskou strukturu: ");
			text->string.set1Value(4, "");
			text->string.set1Value(5, "      F1 - Centrum, F2 - Ctvrt, F3 - Namesti, F4 - Predmesti");
			text->string.set1Value(6, "");
		break;
		case 4:
			viewer->setTitle("- Virtualni town development with roads  -");
			text->string.set1Value(0, "");
			text->string.set1Value(1, "");
			text->string.set1Value(2, "Nove generovani mestske zastavby:   '  '  mezernik.");
			text->string.set1Value(3, "");			
		break;
	} // end switch

	text->justification = SoText2::LEFT;
	posRoot->addChild(text);	

	viewer->setSceneGraph(root);	 
  viewer->show();

  // Zobraz okna a rozjede renderovaci smycku
  SoWin::show(window);
  SoWin::mainLoop();

	// Uvolneni pamet
  delete viewer;
  root->unref();

  return 0;
} // end main
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru Main-Windows.cpp
// =============================================================================