// =============================================================================
// soubor Main-Windows.h
// =============================================================================

#ifndef MainWindows_h_
#define MainWindows_h_

#include <stdio.h>
#include <ctype.h>

#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/Win/viewers/SoWinViewer.h>
#include <Inventor/Win/SoWinRenderArea.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoEventCallback.h> 
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/events/SoKeyboardEvent.h>
#include<Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoAnnotation.h> 

#include "Viewers/keyboard.h"
#include "Viewers/SoScreenPositioner.h"

// Pro linker: Budeme linkovat s main,
// nikoliv WinMain, jak je na Windows zvykem,
// a aplikace bude vyuzivat konzoli.
#pragma comment(linker, "/entry:\"mainCRTStartup\"")
#pragma comment(linker, "/subsystem:\"console\"")

#if defined(_WIN32) || defined(__WIN32__)

class SoMyExaminerViewer : public SoWinExaminerViewer {
  typedef SoWinExaminerViewer inherited;
public:
  SoMyExaminerViewer(HWND parent=NULL, const char *name=NULL, SbBool embed=TRUE, 
    SoWinFullViewer::BuildFlag flag=BUILD_ALL, SoWinViewer::Type type=BROWSER) 
    : inherited(parent, name, embed, flag, type) {}
protected:
  SbBool processSoEvent(const SoEvent *const event) {
    if (!inherited::processSoEvent(event) && isViewing())
      SoWinRenderArea::processSoEvent(event);
    return FALSE;
  }
};

#else

class SoMyExaminerViewer : public SoQtExaminerViewer {
  typedef SoQtExaminerViewer inherited;
  public:
  SoMyExaminerViewer(QWidget *parent=NULL, const char *name=NULL, SbBool embed=TRUE,
    SoQtFullViewer::BuildFlag flag=BUILD_ALL, SoQtViewer::Type type=BROWSER)

  SoMyExaminerViewer(QWidget parent=NULL, const char *name=NULL, SbBool embed=TRUE, 
    SoWinFullViewer::BuildFlag flag=BUILD_ALL, SoWinViewer::Type type=BROWSER) 
    : inherited(parent, name, embed, flag, type) {}
protected:
  SbBool processSoEvent(const SoEvent *const event) {
    if (!inherited::processSoEvent(event) && isViewing())
      return SoQtRenderArea::processSoEvent(event);
    return FALSE;
  }
};

#endif

static SoMyExaminerViewer *viewer; 

extern SoSeparator *CreateBuild(int argc, char **argv);
extern SoSeparator *CreateGener(int argc, char **argv);
extern SoSeparator *CreateStructures(int argc, char **argv);
extern SoSeparator *CreateGenTownFlat(int argc, char **argv);

#endif

// =============================================================================
// konec souboru Main-Windows.h
// =============================================================================
