// =============================================================================
// soubor MakeTownStructure.cpp
// =============================================================================

#include "MakeTownStructure.h"

// -----------------------------------------------------------------------------
// fce.MakeTownStructure - vytvori danou mestskou strukturu
// -----------------------------------------------------------------------------
SoSeparator * MakeTownStructure(int IPs,  // cislo dane struktury
																float x,float y,float z,  // pozice
																float alfa,  // pootoceni
																TEXTURE texture)  { // navic

  alfa=degree_to_radian(0);

  SoSeparator *root = new SoSeparator;

  // umisteni struktlury
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  root->addChild(transform);

  // velikost modelu struktlury
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  root->addChild(scale);

  // rotace modelu struktlury 
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::X;
  root -> addChild(myRotation);

switch (IPs){

	// centra
  case  0: root -> addChild(MakeCentre00()); break;
  case  1: root -> addChild(MakeCentre01()); break;
  case  2: root -> addChild(MakeCentre02()); break;
  case  3: root -> addChild(MakeCentre03()); break;

	// ctvrte
  case  4: root -> addChild(MakeDistrict00()); break;
  case  5: root -> addChild(MakeDistrict01()); break;
  case  6: root -> addChild(MakeDistrict02()); break;
  case  7: root -> addChild(MakeDistrict03()); break;

	// namesti
  case  8: root -> addChild(MakeSquare00()); break;
  case  9: root -> addChild(MakeSquare01()); break;
  case 10: root -> addChild(MakeSquare02()); break;
  case 11: root -> addChild(MakeSquare03()); break;

	// predmesti
	case 12: root -> addChild(MakeSuburb00()); break;
  case 13: root -> addChild(MakeSuburb01()); break;
  case 14: root -> addChild(MakeSuburb02()); break;
  case 15: root -> addChild(MakeSuburb03()); break;

  case 16: root -> addChild(MakeRandomStructure());break;

  default: break;
  }

	MarkRoad(IPs);
	root -> addChild(CreateGround(IPs));

return root;
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru MakeTownStructure.cpp
// =============================================================================