// =============================================================================
// soubor structures.cpp
// =============================================================================

#include "structures.h"

// -----------------------------------------------------------------------------
// prevodni fce. stupne na radiany
// -----------------------------------------------------------------------------
float degree_to_radian(float x) {
  const double PI = 3.1415;
  return (float) (PI/180)*x; 
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// podle vsech rozmeru budovy 
// -----------------------------------------------------------------------------
int SelectBuilding(BY by,int pre_building, float x, float y, float z) {
	int building = 0;

	switch(by) {
		case BY_XYZ: building = by_xyz(pre_building, x, y, z); break;

    case BY_DOWN_MIN: building = by_min_down(pre_building, x, z); break;
    case BY_DOWN_MAX: building = by_max_down(pre_building, x, z); break;

    case BY_HIGH_MIN: building = by_min_high(pre_building, y); break;
    case BY_HIGH_MAX: building = by_max_high(pre_building, y); break;

    case BY_DMIN_HMIN: building = by_min_down_and_min_high(pre_building, x, y, z); break;
    case BY_DMIN_HMAX: building = by_min_down_and_max_high(pre_building, x, y, z); break;
    case BY_DMAX_HMIN: building = by_max_down_and_min_high(pre_building, x, y, z); break;
    case BY_DMAX_HMAX: building = by_max_down_and_max_high(pre_building, x, y, z); break;
	}

	return(building);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// podle vsech rozmeru budovy 
// -----------------------------------------------------------------------------
int by_xyz(int pre_building, float x, float y, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x==GetParamBuilding(building,1) && 
       z==GetParamBuilding(building,2) &&
	     y==GetParamBuilding(building,0)) {
	     i=35;  
	     b=building;  
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// podle velikosti podstavy do MAXima
// -----------------------------------------------------------------------------
int by_max_down(int pre_building, float x, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x>=GetParamBuilding(building,1) && 
       z>=GetParamBuilding(building,2)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle velikosti podstavy od MINima
// -----------------------------------------------------------------------------
int by_min_down(int pre_building, float x, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x<=GetParamBuilding(building,1) && 
       z<=GetParamBuilding(building,2)) {
	     i=35;
	     b=building;
		}
	  else b=100;
	}
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle vysky budovy od MINima
// -----------------------------------------------------------------------------
int by_min_high(int pre_building, float y) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(y<=GetParamBuilding(building,0)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle vysky budovy do MAXima
// -----------------------------------------------------------------------------
int by_max_high(int pre_building, float y) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(y>=GetParamBuilding(building,0)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle velikosti podstavy do MAXima
// a podle vysky budovy od MINima
// -----------------------------------------------------------------------------
int by_max_down_and_min_high(int pre_building, float x, float y, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x>=GetParamBuilding(building,1) && 
       z>=GetParamBuilding(building,2) &&
	     y<=GetParamBuilding(building,0)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle velikosti podstavy do MAXima
// a podle vysky budovy do MAXima
// -----------------------------------------------------------------------------
int by_max_down_and_max_high(int pre_building, float x, float y, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x>=GetParamBuilding(building,1) && 
       z>=GetParamBuilding(building,2) &&
	     y>=GetParamBuilding(building,0)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------



// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle velikosti podstavy do MINima
// a podle vysky budovy od MINima
// -----------------------------------------------------------------------------
int by_min_down_and_min_high(int pre_building, float x, float y, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x<=GetParamBuilding(building,1) && 
       z<=GetParamBuilding(building,2) &&
	     y<=GetParamBuilding(building,0)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle velikosti podstavy do MINima
// a podle vysky budovy do MAXima
// -----------------------------------------------------------------------------
int by_min_down_and_max_high(int pre_building, float x, float y, float z) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if(x<=GetParamBuilding(building,1) && 
       z<=GetParamBuilding(building,2) &&
	     y>=GetParamBuilding(building,0)) {
	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. se snazi vybrat budovu z budov (od predchozi budovy dal)
// a podle velikosti podstavy od x1,z1 do x2,z2
// a podle vysky budovy od y1 do y2
// -----------------------------------------------------------------------------
int SB_from_to_xyz(int pre_building, float x1, float x2, float y1, float y2, float z1, float z2) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	  if(building==34) building = 0;
	  else building++;
	  if( (x1<0 || x2<0 || 
			  (x1<=GetParamBuilding(building,1) && x2>=GetParamBuilding(building,1)) ) &&

			  (z1<0 || z2<0 ||
        (z1<=GetParamBuilding(building,2) && z2>=GetParamBuilding(building,2)) ) &&

			  (y1<0 || y2<0 ||
	      (y1<=GetParamBuilding(building,0) && y2>=GetParamBuilding(building,0)) ) ) {

	     i=35;
	     b=building;
		}
	  else b=100;
  }
  return b;
}
// -----------------------------------------------------------------------------



// -----------------------------------------------------------------------------
// fce.prehodi texturu na nasledujici texturu
// -----------------------------------------------------------------------------
TEXTURE NextTexture(TEXTURE texture) {
	switch(texture) {
		case BRICK: return COLOR; break;
		case COLOR: return STONE; break;
		case STONE: return WOOD; break;
		case WOOD: return BRICK; break;
	}
	return BRICK;
}
// -----------------------------------------------------------------------------



// -----------------------------------------------------------------------------
// fce.vybere pseudonahodne (rand()) texturu
// -----------------------------------------------------------------------------
TEXTURE RandTexture() {

	TEXTURE texture;
	int j,r,max;
	max = RAND_MAX;	
	r=rand();

	if(r%4 == 0) j = 0; else 
	if(r%4 == 1) j = 1; else 
	if(r%4 == 2) j = 2; else 
	j = 3;

	switch(j) {
		case 0: texture = BRICK; break;
		case 1: texture = COLOR; break;
		case 2: texture = STONE; break;
		case 3: texture = WOOD; break;
	}

 // printf("%d ",j);

	return(texture);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vybere pseudonahodne (rand()) texturu
// -----------------------------------------------------------------------------
int RandBuilding() {

	int building,r,max;
	max = RAND_MAX;
	r=rand();

	if((max-r) <= (( 1.f/35.f)*max)) building = 0; else 
	if((max-r) <= (( 2.f/35.f)*max)) building = 1; else 
	if((max-r) <= (( 3.f/35.f)*max)) building = 2; else 
	if((max-r) <= (( 4.f/35.f)*max)) building = 3; else 
	if((max-r) <= (( 5.f/35.f)*max)) building = 4; else 
	if((max-r) <= (( 6.f/35.f)*max)) building = 5; else
	if((max-r) <= (( 7.f/35.f)*max)) building = 6; else 
	if((max-r) <= (( 8.f/35.f)*max)) building = 7; else 
	if((max-r) <= (( 9.f/35.f)*max)) building = 8; else
	if((max-r) <= ((10.f/35.f)*max)) building = 9; else 

	if((max-r) <= ((11.f/35.f)*max)) building = 10; else 
	if((max-r) <= ((12.f/35.f)*max)) building = 11; else 
	if((max-r) <= ((13.f/35.f)*max)) building = 12; else 
	if((max-r) <= ((14.f/35.f)*max)) building = 13; else 
	if((max-r) <= ((15.f/35.f)*max)) building = 14; else 
	if((max-r) <= ((16.f/35.f)*max)) building = 15; else
	if((max-r) <= ((17.f/35.f)*max)) building = 16; else 
	if((max-r) <= ((18.f/35.f)*max)) building = 17; else 
	if((max-r) <= ((19.f/35.f)*max)) building = 18; else
	if((max-r) <= ((20.f/35.f)*max)) building = 19; else 

	if((max-r) <= ((11.f/35.f)*max)) building = 20; else 
	if((max-r) <= ((12.f/35.f)*max)) building = 21; else 
	if((max-r) <= ((13.f/35.f)*max)) building = 22; else 
	if((max-r) <= ((14.f/35.f)*max)) building = 23; else 
	if((max-r) <= ((15.f/35.f)*max)) building = 24; else 
	if((max-r) <= ((16.f/35.f)*max)) building = 25; else
	if((max-r) <= ((17.f/35.f)*max)) building = 26; else 
	if((max-r) <= ((18.f/35.f)*max)) building = 27; else 
	if((max-r) <= ((19.f/35.f)*max)) building = 28; else
	if((max-r) <= ((20.f/35.f)*max)) building = 29; else
		
	if((max-r) <= ((11.f/35.f)*max)) building = 30; else 
	if((max-r) <= ((12.f/35.f)*max)) building = 31; else 
	if((max-r) <= ((13.f/35.f)*max)) building = 32; else 
	if((max-r) <= ((14.f/35.f)*max)) building = 33; else 

	building = 34;

	return(building);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. umisti danou budovu na mapu 
// na pozici(x,y,z) s rotaci alfa a s danou texturou
// -----------------------------------------------------------------------------
SoSeparator* PutBuilding(int building, float x, float z, float alfa, TEXTURE texture) {

  SoSeparator* Building = new SoSeparator;

	/*
  float offset=0.f;
  float zoom=1.f;
  float x1=0.f;
  float x2=0.f;
  float z1=0.f;
  float z2=0.f;

  x1=x-zoom*GetParamBuilding(building,1);
  z1=z-zoom*GetParamBuilding(building,2);
  x2=x+zoom*GetParamBuilding(building,1);
  z2=z+zoom*GetParamBuilding(building,2);
  */

  float pos_x = x;
  float pos_z = z;
  float pos_y = 0;

  Building -> addChild(MakeBuilding(building, 
                                    pos_x, pos_y, pos_z, 
		                                alfa,
																		texture));

  return(Building);
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru structure.cpp
// =============================================================================