// =============================================================================
// soubor BuildViewer.cpp
// =============================================================================

#include "BuildViewer.h"

// IPb(cisla) budov urcujici od kud zacinaji budovy z danou strechou
#define FLAT_ROOF     0  // plochou
#define SADDLE_ROOF  14  // sedlovou
#define PYRAMID_ROOF 24  // pyramidovou, stanovou
#define AISLE_ROOF   28  // sikmou, pultovou

#define IPb_MIN  0  // MIN - prohlizec lze posouvat dokola pro rozpoz.zacatku
#define IPb_MAX 34  // MAX + 1(od nuly) = pocet budov, a konce :)

// init (nastaveni pocatecni budovy pro prohlizec + param)
int IPb=33;  // tvar
TEXTURE TextureB = COLOR;  // textura
int i = 1;  // pomoc pro texturu


// -----------------------------------------------------------------------------
// fce.BuildEvent - obsluha klavesnice
// -----------------------------------------------------------------------------
void BuildEventCB(void * userData, SoEventCallback * node)
{

	SoSeparator * root = (SoSeparator*)userData;
	const SoEvent * event = node->getEvent();

	// sipky jsou v modu (setViewing) u SoExaminerViwer pouzity k pohybu modelu 
	// ve scene a s je priblizeni volim zbivajici tlacitka
	// obsluha pro - UP ARROW, RIGHT ARROW, SPACE sipky(nahoru,doprava), mezernik

	// obsluha pro - '>' vetsitko, '.'tecka SPACE mezernik
	// NEXT - Pohyb po jednotlivych budovach i jejich textur
	if( //SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::UP_ARROW) ||
	    //SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::RIGHT_ARROW) ||
			SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::PERIOD) || // >, .
	    SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::SPACE) ) {
	  i++;
	  root -> removeAllChildren();
		if(i>3) {			
			i=0;
			if(IPb == IPb_MAX) IPb = IPb_MIN;
	    else IPb++;						
		}
		TextureB = SwitchBuildTexture(i);
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - DOWN ARROW, LEFT ARROW sipky(dolu,doleva)

	// obsluha pro - '<' mensitko, ','carka,
	// BACK - Pohyb po jednotlivych budovach i jejich textur
	if(// SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::DOWN_ARROW) ||
	   // SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::LEFT_ARROW) ) {
		  SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::COMMA) ) { // <, ,
	  i--;
	  root -> removeAllChildren();
		if(i<0) {			
			i=3;
			if(IPb == IPb_MIN) IPb = IPb_MAX;
	    else IPb--;						
		}
		TextureB = SwitchBuildTexture(i);
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - PAGE UP
	// NEXT SHAPE - Pohyb po jednotlivych tvarech budov
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::PAGE_UP) ) {
	  i++;
	  root -> removeAllChildren();
  	if(IPb == IPb_MAX) IPb = IPb_MIN;
	  else IPb++;						
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - PAGE DOWN
	// BACK SHAPE - Pohyb po jednotlivych tvarech budov
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::PAGE_DOWN) ) {
	  i--;
	  root -> removeAllChildren();
		if(IPb == IPb_MIN) IPb = IPb_MAX;
	  else IPb--;						
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - F1
	// FLAT_ROOF - Nastaveni na prvni budovu dane strechy
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F1) ) {	  
	  root -> removeAllChildren();
		i=0;
		TextureB = SwitchBuildTexture(i);
		IPb = FLAT_ROOF;
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - F2
	// SADDLE_ROOF - Nastaveni na prvni budovu dane strechy
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F2) ) {	  
	  root -> removeAllChildren();
		i=0;
		TextureB = SwitchBuildTexture(i);					
		IPb = SADDLE_ROOF;
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - F3
	// AISLE_ROOF - Nastaveni na prvni budovu dane strechy
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F3) ) {	  
	  root -> removeAllChildren();
		i=0;
		TextureB = SwitchBuildTexture(i);					
		IPb = AISLE_ROOF;
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - F4
	// PYRAMID_ROOF - Nastaveni na prvni budovu dane strechy
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F4) ) {	  
	  root -> removeAllChildren();
		i=0;
		TextureB = SwitchBuildTexture(i);					
		IPb = PYRAMID_ROOF;
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

/*
	// !!! S zabrano SoExaminerViwer pro priblizeni sceny

	// obsluha pro - B,b
	// BRICK - Nastaveni textury pro aktualni budovu 
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::B) ) {	  
	  root -> removeAllChildren();
		i=0;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - C,c
	// COLOR - Nastaveni textury pro aktualni budovu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::C) ) {	  
	  root -> removeAllChildren();
		i=1;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// S zabrano SoExaminerViwer pro priblizeni sceny
	// obsluha pro - S,s
	// STONE - Nastaveni textury pro aktualni budovu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::S) ) {	  
	  root -> removeAllChildren();
		i=2;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - W,w
	// WOOD - Nastaveni textury pro aktualni budovu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::W) ) {	  
	  root -> removeAllChildren();
		i=3;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }
*/
	// obsluha pro - 1
	// BRICK - Nastaveni textury pro aktualni budovu 
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::NUMBER_1) ) {	  
	  root -> removeAllChildren();
		i=0;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - 2
	// COLOR - Nastaveni textury pro aktualni budovu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::NUMBER_2) ) {	  
	  root -> removeAllChildren();
		i=1;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// S zabrano SoExaminerViwer pro priblizeni sceny
	// obsluha pro - 3
	// STONE - Nastaveni textury pro aktualni budovu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::NUMBER_3) ) {	  
	  root -> removeAllChildren();
		i=2;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	// obsluha pro - 4
	// WOOD - Nastaveni textury pro aktualni budovu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::NUMBER_4) ) {	  
	  root -> removeAllChildren();
		i=3;
		TextureB = SwitchBuildTexture(i);					
		root -> addChild(MakeBuilding(IPb,0,0,0,10,TextureB));
  }

	node->setHandled();
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.CreateBuild - vraci budovu podle 
// (IPb budovy,na pozice 0,0,0,s uhlem otoceni 10 stupnu,s texturou TextureB)
// -----------------------------------------------------------------------------
SoSeparator* CreateBuild(int argc, char **argv) { 	
	return MakeBuilding(IPb,0,0,0,10,TextureB);		
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru BuildViewer.cpp
// =============================================================================