// =============================================================================
// soubor TownStructureViewer.cpp
// =============================================================================

#include "TownStructureViewer.h"

// IPs(cisla) struktur urcujici od kud zacinaji 
#define CENTER     0  // center
#define DISTRICT   4  // ctvrti
#define SQUARE     8  // namesti
#define SUBURB    12  // predmesti

#define IPs_MIN   0  // zarazky prohlizec bezi do kola (..14->15->0->1..)
#define IPs_MAX  15  // i v druhem smeru (..1->0->15->14..)

// init (nastaveni pocatecni struktury pro prohlizec + param)
int IPs=0;  // typ
TEXTURE TextureS = BRICK;  // textura zatim navic 

// -----------------------------------------------------------------------------
// fce.StructEvent - obsluha klavesnice
// -----------------------------------------------------------------------------
void StructEventCB(void * userData, SoEventCallback * node) {

	SoSeparator * root = (SoSeparator*)userData;
	const SoEvent * event = node->getEvent();

	// Zabrano obsluha pro - UP ARROW, RIGHT ARROW, SPACE sipky(nahoru,doprava), mezernik

	// obsluha pro - '>' vetsitko, '.'tecka SPACE mezernik
	// NEXT - Pohyb po jednotlivych strukturach
	if( //SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::UP_ARROW) ||
	    //SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::RIGHT_ARROW) ||
			SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::PERIOD) || // >, .
	    SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::SPACE) ) {
	  if(IPs == IPs_MAX) IPs = IPs_MIN;
	  root -> removeAllChildren();
	  root -> addChild(MakeTownStructure(++IPs,0,0,0,10,BRICK));
  }

	// Zabrano obsluha pro - DOWN ARROW, LEFT ARROW sipky(dolu,doleva)

	// obsluha pro - '<' mensitko, ','carka,
	// BACK - Pohyb po jednotlivych strukturach i jejich textur
	if( //SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::DOWN_ARROW) ||
	    //SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::LEFT_ARROW) 
			SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::COMMA) ) { // <, ,
	  if(IPs == IPs_MIN) IPs = IPs_MAX;
	  root -> removeAllChildren();
	  root -> addChild(MakeTownStructure(--IPs,0,0,0,10,BRICK));
  }

	// obsluha pro - F1
	// CENTER - Nastaveni na prvni strukturu daneho typu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F1) ) {	  
	  root -> removeAllChildren();
		IPs = CENTER;
		root -> addChild(MakeTownStructure(IPs,0,0,0,10,TextureS));
  }

	// obsluha pro - F2
	// DISTRICT - Nastaveni na prvni strukturu daneho typu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F2) ) {	  
	  root -> removeAllChildren();		
		IPs = DISTRICT;
		root -> addChild(MakeTownStructure(IPs,0,0,0,10,TextureS));
  }

	// obsluha pro - F3
	// SQUARE - Nastaveni na prvni strukturu daneho typu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F3) ) {	  
	  root -> removeAllChildren();				
		IPs = SQUARE;
		root -> addChild(MakeTownStructure(IPs,0,0,0,10,TextureS));
  }

	// obsluha pro - F4
	// SUBURB - Nastaveni na prvni strukturu daneho typu
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::F4) ) {	  
	  root -> removeAllChildren();				
		IPs = SUBURB;
		root -> addChild(MakeTownStructure(IPs,0,0,0,10,TextureS));
  }

	node->setHandled();
} 
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.CreateStructures - vraci strukturu podle 
// (IPs struktury,na pozice 0,0,0,s uhlem otoceni 10 stupnu,s texturou)
// -----------------------------------------------------------------------------
SoSeparator* CreateStructures(int argc, char **argv) {
  return MakeTownStructure(IPs,0,0,0,10,TextureS);
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru TownStructureViewer.cpp
// =============================================================================