// =============================================================================
// soubor ground.cpp
// =============================================================================

#include "ground.h"

// -----------------------------------------------------------------------------
// fce.Create Ground - vyvtvori povrch struktury ground
// skladajici se z jednotlivych kusu podle velikosti rastru 
// -----------------------------------------------------------------------------
SoSeparator* CreateGround(int c) {

const int rastr = 16;//100;
int i,j,k;
float max, add_max, x1, x2, setina, x2start;

// velikost podlozky pro vsechny stejna
//if(c<20) {max = 13.5f;add_max=1.f;}
//else    {max = 30.f ;add_max=5.f;}

max = MAX_GROUND;//13.5f;
add_max=1.f;

i=j=k=1;
x1 = (-add_max); // -1
setina = ((max + 2*add_max)*(1.f/rastr));
x2 = x1; // x1  
x2start = x2;

SoSeparator* ground = new SoSeparator;

for(i=1;i<=rastr;i++,x1+=setina) {
	for(j=1;j<=rastr;j++,x2+=setina) {
	  ground -> addChild(SetGround(c,x1,x2,(setina),k, i, j));
		k++;
	}
	x2 = x2start;
	k++;
}

return(ground);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.SetGround - vyvtvori dany kus povrchu part_of_ground 
// hlavne ho otexturuje prislusnou texturou 
// pomoci fce.OnGround(i,j) v ktera vraci vraci hodnoty prvku pole Ground[i][j]
// -----------------------------------------------------------------------------
SoSeparator* SetGround(int c,float x1,float x2,float h,int k,int i,int j) {

float part_of_ground_vertices[][3] = {
	     x1,   0, x2,    // 0  
	     x1+h, 0, x2,    // 1
	     x1,   0, x2+h,	 // 2
			 x1+h, 0, x2+h,  // 3
};

static float part_of_ground_normal[][3] = {
    1, 0, 0, // 1 x
	  0, 1, 0, // 1 y
};

static int32_t part_of_ground_indices[] = { 0,1,2,3, -1 };
static int normalIndex_part_of_ground[] = { 1, 1 };

  SoSeparator* part_of_ground = new SoSeparator;

  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 11, part_of_ground_normal);
  part_of_ground -> addChild(myNormals); 

  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  part_of_ground -> addChild(myNormalBinding);

  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(part_of_ground_vertices)/(3*sizeof(float)), part_of_ground_vertices);
  part_of_ground->addChild(coords);

  // 'vyrez textury' (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  part_of_ground->addChild(texCoord);

	SoMaterial *material = new SoMaterial;

  // otexturavani
  SoTexture2 *texture_f00 = new SoTexture2;
  part_of_ground -> addChild(texture_f00);

	//printf("\n\t %d %d  %d",i-1,j-1,OnGround((i-1),(j-1)));

	switch(OnGround(i-1,j-1)) {

    // trava
		case GRASS: texture_f00 -> filename.setValue("Texture/road/grass/grass.PNG"); break;

    // chodnik		
		case PAWEMENT: texture_f00 -> filename.setValue("Texture/road/pawement/pawement.PNG"); break;

		case PAWEMENT_45L_L: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45L_L.PNG"); break;
		case PAWEMENT_45L_R: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45L_R.PNG"); break;
		case PAWEMENT_45R_L: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45R_L.PNG"); break;
		case PAWEMENT_45R_R: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45R_R.PNG"); break;

		case PAWEMENT_45C_U: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45C_U.PNG"); break;
		case PAWEMENT_45C_D: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45C_D.PNG"); break;
		case PAWEMENT_45C_L: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45C_L.PNG"); break;
		case PAWEMENT_45C_R: texture_f00 -> filename.setValue("Texture/road/pawement/pawement_45C_R.PNG"); break;

		case SIDEWALK_UP: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_up.PNG"); break;
		case SIDEWALK_DOWN: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_down.PNG"); break;
		case SIDEWALK_LEFT: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_left.PNG"); break;
		case SIDEWALK_RIGHT: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_right.PNG"); break;

		case SIDEWALK_C_LU: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_C_LU.PNG"); break;
		case SIDEWALK_C_LD: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_C_LD.PNG"); break;
		case SIDEWALK_C_RU: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_C_RU.PNG"); break;
		case SIDEWALK_C_RD: texture_f00 -> filename.setValue("Texture/road/sidewalk/sidewalk_C_RD.PNG"); break;
     

		// silnice jednosmerka 
		case ROAD01_VERT: texture_f00 -> filename.setValue("Texture/road/road01/road01_vertical.PNG"); break;
		case ROAD01_HORIZ: texture_f00 -> filename.setValue("Texture/road/road01/road01_horizontal.PNG"); break;
		case ROAD01_CROSS: texture_f00 -> filename.setValue("Texture/road/road01/road01_cross.PNG"); break;

		case ROAD01_CROSS_TL: texture_f00 -> filename.setValue("Texture/road/road01/road01_crossTL.PNG"); break;
		case ROAD01_CROSS_TR: texture_f00 -> filename.setValue("Texture/road/road01/road01_crossTR.PNG"); break;
		case ROAD01_CROSS_TD: texture_f00 -> filename.setValue("Texture/road/road01/road01_crossTD.PNG"); break;
		case ROAD01_CROSS_TU: texture_f00 -> filename.setValue("Texture/road/road01/road01_crossTU.PNG"); break;

		case ROAD01_90DL: texture_f00 -> filename.setValue("Texture/road/road01/road01_90DL.PNG"); break;
		case ROAD01_90DR: texture_f00 -> filename.setValue("Texture/road/road01/road01_90DR.PNG"); break;
		case ROAD01_90UL: texture_f00 -> filename.setValue("Texture/road/road01/road01_90UL.PNG"); break;
		case ROAD01_90UR: texture_f00 -> filename.setValue("Texture/road/road01/road01_90UR.PNG"); break;

		case ROAD01_45L_L: texture_f00 -> filename.setValue("Texture/road/road01/road01_45L_L.PNG"); break;
		case ROAD01_45L_M: texture_f00 -> filename.setValue("Texture/road/road01/road01_45L_M.PNG"); break;
		case ROAD01_45L_R: texture_f00 -> filename.setValue("Texture/road/road01/road01_45L_R.PNG"); break;

		case ROAD01_45R_L: texture_f00 -> filename.setValue("Texture/road/road01/road01_45R_L.PNG"); break;
		case ROAD01_45R_M: texture_f00 -> filename.setValue("Texture/road/road01/road01_45R_M.PNG"); break;
		case ROAD01_45R_R: texture_f00 -> filename.setValue("Texture/road/road01/road01_45R_R.PNG"); break;

		case ROAD01_C02_L: texture_f00 -> filename.setValue("Texture/road/road01/road01_C02_L.PNG"); break;
		case ROAD01_C02_R: texture_f00 -> filename.setValue("Texture/road/road01/road01_C02_R.PNG"); break;
		case ROAD01_C02_D: texture_f00 -> filename.setValue("Texture/road/road01/road01_C02_D.PNG"); break;
		case ROAD01_C02_U: texture_f00 -> filename.setValue("Texture/road/road01/road01_C02_U.PNG"); break;

		case ROAD01_45C02_LU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02_LU.PNG"); break;
		case ROAD01_45C02_LD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02_LD.PNG"); break;
		case ROAD01_45C02_RU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02_RU.PNG"); break;
		case ROAD01_45C02_RD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02_RD.PNG"); break;

		case ROAD01_45_C02_LU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_C02_LU.PNG"); break;
		case ROAD01_45_C02_LD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_C02_LD.PNG"); break;
		case ROAD01_45_C02_RU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_C02_RU.PNG"); break;
		case ROAD01_45_C02_RD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_C02_RD.PNG"); break;

		case ROAD01_45C02L_DU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02L_DU.PNG"); break;
		case ROAD01_45C02L_UD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02L_UD.PNG"); break;
		case ROAD01_45C02R_DU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02R_DU.PNG"); break;
		case ROAD01_45C02R_UD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02R_UD.PNG"); break;
		case ROAD01_45C02D_LR: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02D_LR.PNG"); break;
		case ROAD01_45C02D_RL: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02D_RL.PNG"); break;
		case ROAD01_45C02U_LR: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02U_LR.PNG"); break;
		case ROAD01_45C02U_RL: texture_f00 -> filename.setValue("Texture/road/road01/road01_45C02U_RL.PNG"); break;

		case ROAD01_45_CP_LU_LD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_LU_LD.PNG"); break;
		case ROAD01_45_CP_LD_LU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_LD_LU.PNG"); break;
		case ROAD01_45_CP_RU_RD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_RU_RD.PNG"); break;
		case ROAD01_45_CP_RD_RU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_RD_RU.PNG"); break;
		case ROAD01_45_CP_LU_RU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_LU_RU.PNG"); break;
		case ROAD01_45_CP_LD_RD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_LD_RD.PNG"); break;
		case ROAD01_45_CP_RU_LU: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_RU_LU.PNG"); break;
		case ROAD01_45_CP_RD_LD: texture_f00 -> filename.setValue("Texture/road/road01/road01_45_CP_RD_LD.PNG"); break;

		case ROAD01_45TL_11: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_11.PNG"); break;
		case ROAD01_45TL_12: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_12.PNG"); break;
		case ROAD01_45TL_21: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_21.PNG"); break;
		case ROAD01_45TL_22: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_22.PNG"); break;
		case ROAD01_45TL_31: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_31.PNG"); break;
		case ROAD01_45TL_32: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_32.PNG"); break;
		case ROAD01_45TL_41: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_41.PNG"); break;
		case ROAD01_45TL_42: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TL_42.PNG"); break;

		case ROAD01_45TR_11: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_11.PNG"); break;
		case ROAD01_45TR_12: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_12.PNG"); break;
		case ROAD01_45TR_21: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_21.PNG"); break;
		case ROAD01_45TR_22: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_22.PNG"); break;
		case ROAD01_45TR_31: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_31.PNG"); break;
		case ROAD01_45TR_32: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_32.PNG"); break;
		case ROAD01_45TR_41: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_41.PNG"); break;
		case ROAD01_45TR_42: texture_f00 -> filename.setValue("Texture/road/road01/road01_45TR_42.PNG"); break;


		// silnice obousmerka 
		case ROAD02_VERT: texture_f00 -> filename.setValue("Texture/road/road02/road02_vertical.PNG"); break;
		case ROAD02_HORIZ: texture_f00 -> filename.setValue("Texture/road/road02/road02_horizontal.PNG"); break;
		case ROAD02_CROSS: texture_f00 -> filename.setValue("Texture/road/road02/road02_cross.PNG"); break;

		case ROAD02_45L_L: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L_L.PNG"); break;
		case ROAD02_45L_M: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L_M.PNG"); break;
		case ROAD02_45L_R: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L_R.PNG"); break;

		case ROAD02_45R_L: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R_L.PNG"); break;
		case ROAD02_45R_M: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R_M.PNG"); break;
		case ROAD02_45R_R: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R_R.PNG"); break;

		case ROAD02_90T_DL: texture_f00 -> filename.setValue("Texture/road/road02/road02_90T_DL.PNG"); break;
		case ROAD02_90T_DR: texture_f00 -> filename.setValue("Texture/road/road02/road02_90T_DR.PNG"); break;
		case ROAD02_90T_UL: texture_f00 -> filename.setValue("Texture/road/road02/road02_90T_UL.PNG"); break;
		case ROAD02_90T_UR: texture_f00 -> filename.setValue("Texture/road/road02/road02_90T_UR.PNG"); break;

		case ROAD02_45C_U: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_U.PNG"); break;
		case ROAD02_45C_D: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_D.PNG"); break;
		case ROAD02_45C_L: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_L.PNG"); break;
		case ROAD02_45C_R: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_R.PNG"); break;

		case ROAD02_45C_LU: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_LU.PNG"); break;
		case ROAD02_45C_LD: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_LD.PNG"); break;
		case ROAD02_45C_RU: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_RU.PNG"); break;
		case ROAD02_45C_RD: texture_f00 -> filename.setValue("Texture/road/road02/road02_45C_RD.PNG"); break;

		case ROAD02_CROSS_45L11: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L11cross.PNG"); break;
		case ROAD02_CROSS_45L12: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L12cross.PNG"); break;
		case ROAD02_CROSS_45L21: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L21cross.PNG"); break;
		case ROAD02_CROSS_45L22: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L22cross.PNG"); break;
		case ROAD02_CROSS_45L31: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L31cross.PNG"); break;
		case ROAD02_CROSS_45L32: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L32cross.PNG"); break;
		case ROAD02_CROSS_45L41: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L41cross.PNG"); break;
		case ROAD02_CROSS_45L42: texture_f00 -> filename.setValue("Texture/road/road02/road02_45L42cross.PNG"); break;

		case ROAD02_CROSS_45R11: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R11cross.PNG"); break;
		case ROAD02_CROSS_45R12: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R12cross.PNG"); break;
		case ROAD02_CROSS_45R21: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R21cross.PNG"); break;
		case ROAD02_CROSS_45R22: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R22cross.PNG"); break;
		case ROAD02_CROSS_45R31: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R31cross.PNG"); break;
		case ROAD02_CROSS_45R32: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R32cross.PNG"); break;
		case ROAD02_CROSS_45R41: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R41cross.PNG"); break;
		case ROAD02_CROSS_45R42: texture_f00 -> filename.setValue("Texture/road/road02/road02_45R42cross.PNG"); break;
	}

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(part_of_ground_indices)/sizeof(int32_t), part_of_ground_indices);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_part_of_ground)/sizeof(int), normalIndex_part_of_ground);

	part_of_ground -> addChild(stripSet);

	return(part_of_ground);
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru ground.cpp
// =============================================================================