// =============================================================================
// soubor road.cpp
// =============================================================================

#include "ground.h"

// !!!! POZOR zvetseno o jedno ok nevim co mu vadi
#define MAX_G 16//(int)(MAX_GROUND - 1)
GROUND Ground[MAX_G][MAX_G];

// -----------------------------------------------------------------------------
// fce.diagonalne oznaci ground
// LEFT  / zhora od (x1,y1) dolu do (x2,y2)
// RIGHT \ zhora od (x1,y1) dolu do (x2,y2)
// -----------------------------------------------------------------------------
void FillDiagonal(GROUND ground,int x1,int y1,int x2,int y2) {
	int i,j,k,l,s,m;
	i=j=k=l=s=m=0;
	i=x1; j=y1;
	if(x1<x2) { s=+1; k=x2-x1; }  //LEFT
	else      { s=-1; k=x1-x2; }  //RIGHT
	// korekce 0..15 na 1..16
	if(x1==0 || y1==0 || x2==0 || y2==0) { k++; l++; }
	if(k!=(y2-y1+l)) printf("\n Body nelezi na jedne diagonale");
	else
	  for(m=0; m<=k; i+=s,j++,m++) 
			Ground[i][j] = ground;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro centre00
// -----------------------------------------------------------------------------
void MarkRoad_centre00() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = PAWEMENT;
			if(j==4 && (i==1 || i==2 || i==3) ||
				 j==6 && i>8 && i<15 || 
				 j==7 && i>4 && i<8 || 
				 j==10 && (i==4 || i==5) ||
				 j==10 && i>9 && i<15 ||
				 j==12 && (i==1 || i==2 || i==7 || i==8))
			  Ground[i][j] = ROAD01_HORIZ;
			if(i==3 && j>10 && j<15 || 
				 i==4 && (j==5 || j==6) ||
				 (i==6 || i==9) && j==11 ||
				 i==10 && (j==1 || j==2) ||
				 i==11 && j>3 && j<10)
			  Ground[i][j] = ROAD01_VERT;
      if(i==4 && j==7 || i==6 && j==12 || i==10 && j==3)
			  Ground[i][j] = ROAD01_90DL;
      if(i==4 && j==4 || i==6 && j==10 || i==11 && j==3)
			  Ground[i][j] = ROAD01_90UL;
      if(i==8 && j==7 || i==9 && j==12)
			  Ground[i][j] = ROAD01_90DR;
      if(j==10 && (i==3 || i==9) || j==6 && i==8 )
			  Ground[i][j] = ROAD01_90UR;
			if(i==11 && j==10) Ground[i][j] = ROAD01_CROSS_TD; 
			if(i==3 && j==12) Ground[i][j] = ROAD01_CROSS_TL;
			if(i==11 && j==6) Ground[i][j] = ROAD01_CROSS;
			if(j==0 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==15) && 
				 (j==0 || j==15)) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro centre01
// -----------------------------------------------------------------------------
void MarkRoad_centre01() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = PAWEMENT;
			if(j==3 || j==12 ||
				(j==7 || j==8) && (i>0 && i<5 || i>10 && i<15) || 
				(j==5 || j==10) && (i==6 || i==9) ) 
				Ground[i][j] = ROAD01_HORIZ;
			if((i==7 || i==8) && (j>0 && j<5 || j>10 && j<15) ||
				 (i==5 || i==10) && (j==6 || j==9) )
				Ground[i][j] = ROAD01_VERT;
			if(i==5 && j==5) Ground[i][j] = ROAD01_90UR;
			if(i==5 && j==10) Ground[i][j] = ROAD01_90DL;
			if(i==10 && j==5) Ground[i][j] = ROAD01_90UL;
			if(i==10 && j==10) Ground[i][j] = ROAD01_90DR;
			if((j==7 || j==8) && i==5 || i==7 && (j==3 || j==12)) 
				Ground[i][j] = ROAD01_CROSS_TL;
			if((j==7 || j==8) && i==10 || i==8 && (j==3 || j==12)) 
				Ground[i][j] = ROAD01_CROSS_TR;
			if((i==7 || i==8) && j==5) Ground[i][j] = ROAD01_CROSS_TD;
			if((i==7 || i==8) && j==10) Ground[i][j] = ROAD01_CROSS_TU;			
			if(j==0 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==15) && (j==0 || j==15)) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro centre02
// -----------------------------------------------------------------------------
void MarkRoad_centre02() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==1 || i==6 || i==9 || i==14 ||
				 j==5 || j==7 || j==10 || j==12 ||
				 j==1 || j==14 ) Ground[i][j] = PAWEMENT;
			if(j==6 || j==11) Ground[i][j] = ROAD01_HORIZ;
			if(i==8 && j==6) Ground[i][j] = ROAD01_CROSS_TD;
			if(i==8 && j==11) Ground[i][j] = ROAD01_CROSS_TU;
			if(j==0 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==15) && (j==0 || j==15) ||
				 (i==7 || i==8) && ((j>1 && j<6) || (j>11 && j<14)) ) 
				 Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro centre03
// -----------------------------------------------------------------------------
void MarkRoad_centre03() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==1 || i==7 || i== 8 || i==14 || 
				 j==1 || j==14 || 
				(j==6 || j==9) && i<6 ) Ground[i][j] = PAWEMENT;
			if(i==6 || i==9) Ground[i][j] = ROAD01_VERT;
			if((j==6 || j==12) && i>9 ) Ground[i][j] = ROAD01_HORIZ;
			if(i==9 && (j==6 || j==12)) Ground[i][j] = ROAD01_CROSS_TR;
			if(j==0 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==15) && (j==0 || j==15) ||
				 (j==7 || j==8) && i<6) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro square00
// -----------------------------------------------------------------------------
void MarkRoad_square00() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==0 && j==12 || i>8 && j==8) Ground[i][j] = SIDEWALK_UP;
			if(i<2 && j==14 || i>8 && j==10) Ground[i][j] = SIDEWALK_DOWN;
			if(i==12 || i==8 && j>8 || i==1 && j<4) Ground[i][j] = SIDEWALK_RIGHT;
			if(i==14 || i==10 && j>9 || i==3 && j<3) Ground[i][j] = SIDEWALK_LEFT;
			if(i==12 && j==8) Ground[i][j] = SIDEWALK_C_RU;
			if(i==12 && j==10) Ground[i][j] = SIDEWALK_C_RD;
			if(i==14 && j==8) Ground[i][j] = SIDEWALK_C_LU;
			if(i==14 && j==10) Ground[i][j] = SIDEWALK_C_LD;
			if(i==10 && j==10) Ground[i][j] = SIDEWALK_C_LD;
			if(i==13 || i==9 && j>9 || i==2 && j<3) Ground[i][j] = ROAD02_VERT;
			if(j==9 && i>9 || i==0 && j==13) Ground[i][j] = ROAD02_HORIZ;
			if(i==9 && j==9 || i==13 && j==9) Ground[i][j] = ROAD02_CROSS;
		}
		FillDiagonal(PAWEMENT_45R_L,  7,0, 1,6);
		FillDiagonal(ROAD02_45L_L,    8,0, 2,6);
		FillDiagonal(ROAD02_45L_M,    9,0, 3,6);
		FillDiagonal(ROAD02_45L_R,   10,0, 4,6);
		FillDiagonal(PAWEMENT_45R_R, 11,0, 5,6);

		FillDiagonal(PAWEMENT_45R_L,  7,5, 0,12);
		FillDiagonal(ROAD02_45L_L,    8,5, 1,12);
		FillDiagonal(ROAD02_45L_M,    9,5, 2,12);
		FillDiagonal(ROAD02_45L_R,   10,5, 3,12);
		FillDiagonal(PAWEMENT_45R_R, 11,5, 4,12);

		FillDiagonal(ROAD02_45R_L,    2,4, 2,4);
		FillDiagonal(ROAD02_45R_M,    2,3, 4,5);
		FillDiagonal(ROAD02_45R_R,    3,3, 3,3);
		FillDiagonal(PAWEMENT_45L_R,  3,2, 3,2);

		FillDiagonal(PAWEMENT_45L_R,  9,2, 11,4);
		FillDiagonal(ROAD02_45R_R,    8,2, 10,4);
		FillDiagonal(ROAD02_45R_M,    7,2, 9,4);
		FillDiagonal(ROAD02_45R_L,    7,3, 8,4);

		FillDiagonal(PAWEMENT_45L_R,  0,8, 1,9);
		FillDiagonal(ROAD02_45R_L,    1,8, 3,10);
		FillDiagonal(ROAD02_45R_M,    2,8, 4,10);
		FillDiagonal(ROAD02_45R_R,    3,8, 4,9);

		FillDiagonal(ROAD02_45R_R,    0, 8, 1,9);
		FillDiagonal(ROAD02_45R_M,    0, 9, 1,10);
		FillDiagonal(ROAD02_45R_L,    0,10, 1,11);
		FillDiagonal(PAWEMENT_45L_L,  0,11, 1,12);

		FillDiagonal(PAWEMENT_45L_R,   5,12, 8,15);
		FillDiagonal(ROAD02_45R_R,     4,12, 7,15);
		FillDiagonal(ROAD02_45R_M,     3,12, 6,15);
		FillDiagonal(ROAD02_45R_L,     3,13, 5,15);
		FillDiagonal(PAWEMENT_45L_L,   2,13, 4,15);

		Ground[9][2] = PAWEMENT_45C_R;
		Ground[8][2] = ROAD02_45C_R;
		Ground[7][2] = ROAD02_45C_LD;
		Ground[7][3] = ROAD02_45C_U;
		Ground[7][4] = PAWEMENT_45C_U;

		Ground[4][3] = PAWEMENT_45C_D;
		Ground[4][4] = ROAD02_45C_D;
		Ground[4][5] = ROAD02_45C_RU;
		Ground[3][5] = ROAD02_45C_L;
		Ground[2][5] = PAWEMENT_45C_L;

		Ground[3][10] = ROAD02_45C_L;
		Ground[4][10] = ROAD02_45C_RU;
		Ground[4][9] = ROAD02_45C_D;
		Ground[4][8] = PAWEMENT_45C_D;

		Ground[2][3] = ROAD02_CROSS_45R11;

		Ground[0][7] = PAWEMENT_45C_D;

		Ground[2][12] = ROAD02_45L_M;
		Ground[1][13] = ROAD02_CROSS_45R21;
		Ground[1][12] = ROAD02_CROSS_45R22;
		Ground[2][13] = ROAD02_45L_R;

		Ground[8][8] = ROAD01_45_CP_LU_LD;
		Ground[8][9] = ROAD01_45TL_41;
		Ground[7][8] = ROAD01_45_C02_LD;
		Ground[7][9] = ROAD01_45_CP_RD_LD;

		Ground[3][2] = PAWEMENT;
		Ground[0][12] = SIDEWALK_UP;
		Ground[8][15] = PAWEMENT;

}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro square01
// -----------------------------------------------------------------------------
void MarkRoad_square01() {

	FillDiagonal(ROAD01_45R_R,   1,0, 4,3);
	FillDiagonal(ROAD01_45R_M,   2,0, 5,3);
	FillDiagonal(ROAD01_45R_L,   3,0, 6,3);

	FillDiagonal(ROAD01_45L_R,   6,10, 1,15);
	FillDiagonal(ROAD01_45L_M,   7,10, 2,15);
	FillDiagonal(ROAD01_45L_L,   8,10, 3,15);

	FillDiagonal(PAWEMENT_45L_R, 0,1, 14,15);
	FillDiagonal(ROAD02_45R_R,   0,2, 13,15);
	FillDiagonal(ROAD02_45R_M,   0,3, 12,15);
	FillDiagonal(ROAD02_45R_L,   0,4, 11,15);
	FillDiagonal(PAWEMENT_45L_L, 0,5, 10,15);

	FillDiagonal(PAWEMENT_45R_L, 10,0, 0,10);
	FillDiagonal(ROAD02_45L_L,   11,0, 0,11);
	FillDiagonal(ROAD02_45L_M,   12,0, 0,12);
	FillDiagonal(ROAD02_45L_R,   13,0, 0,13);
	FillDiagonal(PAWEMENT_45R_R, 14,0, 0,14);
	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			if(i==8 || i==10 || (j==4 || j==6) && i>10) Ground[i][j] = PAWEMENT;
			if(i==9) Ground[i][j] = ROAD02_VERT;
			if(j==5 && i>9) Ground[i][j] = ROAD02_HORIZ;
			if(i==9 && j==5) Ground[i][j] = ROAD02_CROSS;
		}
	Ground[11][0] = ROAD02_45L_L;
	Ground[15][0] = GRASS;

	Ground[6][10] = ROAD01_45C02R_DU;
	Ground[6][11] = ROAD01_45L_M;
	Ground[7][11] = ROAD01_45C02D_RL;
	Ground[7][10] = ROAD01_45C02_RD;

	Ground[6][5] = ROAD01_45C02R_UD;
	Ground[6][4] = ROAD01_45R_M;
	Ground[7][4] = ROAD01_45C02U_RL;
	Ground[7][5] = ROAD01_45C02_RU;

	Ground[8][3] = ROAD02_45L_L;
	Ground[8][4] = ROAD02_45L_M;
	Ground[8][5] = ROAD02_45L_R;
	Ground[10][1] = ROAD02_45L_L;
	Ground[10][2] = ROAD02_45L_M;
	Ground[10][3] = ROAD02_45L_R;

  Ground[8][10] = ROAD02_45R_R;
	Ground[8][11] = ROAD02_45R_M;
  Ground[8][12] = ROAD02_45R_L;
  Ground[10][12] = ROAD02_45R_R;
	Ground[10][13] = ROAD02_45R_M;
  Ground[10][14] = ROAD02_45R_L;

	Ground[4][6] = ROAD02_45R_R;
	Ground[6][8] = ROAD02_45R_R;
	FillDiagonal(ROAD02_45R_M, 4,7, 5,8);
	Ground[3][7] = ROAD02_45R_L;
	Ground[5][9] = ROAD02_45R_L;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro square02
// -----------------------------------------------------------------------------
void MarkRoad_square02() {
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if((i==6 || i==8) && (j<6 || j>9) ||
				 j==6 || j==9 ||
				 ((i==5 || i==9) && (j==5 || j==10)) ) Ground[i][j] = PAWEMENT;			
			if(j==2 || j==13) Ground[i][j] = ROAD01_HORIZ;
			if(i==7 && (j<6 || j>9)) Ground[i][j] = ROAD02_VERT;
			if((j==7 || j==8) && (i<5 || i>9) ||
				  j==6 && i>5 && i<9 || 
				  j==9 && i>5 && i<9) Ground[i][j] = ROAD02_HORIZ;
			if(i==7 && (j==2 || j==6 || j==9 || j==13) ||
				(i==5 || i==9) && (j==7 || j==8) ) Ground[i][j] = ROAD02_CROSS;
		}
		Ground[5][6] = ROAD02_90T_UR;
		Ground[9][6] = ROAD02_90T_UL;
		Ground[5][9] = ROAD02_90T_DR;
		Ground[9][9] = ROAD02_90T_DL;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro square03
// -----------------------------------------------------------------------------
void MarkRoad_square03() {
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==3 || i==5 ||
				 i==11 && j==9 ||
				(j==6 || j==8 || j==10 || j==12) && i>5 && i<13 ||
				 i==13 && j>5 && j<13) Ground[i][j] = PAWEMENT;			
			if( j==2 || 
				 (j==7 || j==11) && i<4 ||
				  j==7 && i>12) Ground[i][j] = ROAD01_HORIZ;
      if(i==12 && j>11) Ground[i][j] = ROAD01_VERT;
			if(i==4 ||
				 i==12 && j>7 && j<11) Ground[i][j] = ROAD02_VERT;
			if((j==7 || j==11) && (i>4 && i<12))Ground[i][j] = ROAD02_HORIZ;
			if((i==4 || i==12) && (j==7 || j==11) ) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro district00
// -----------------------------------------------------------------------------
void MarkRoad_district00() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==1 || i==6 || i== 8 || i==14 || 
				 j==1 || j==7 || j== 9 || j==14) Ground[i][j] = PAWEMENT;
			if(j==0 || j==8 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==7 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==7 || i==15) && 
				 (j==0 || j==8 || j==15)) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro district01
// -----------------------------------------------------------------------------
void MarkRoad_district01() {
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==1 || i==4 || i== 6 || i==9 || i== 11 || i==14 || 
				 j==1 || j==14) Ground[i][j] = PAWEMENT;
			if(i>5 && i<10  && j==5) Ground[i][j] = ROAD01_HORIZ;
			if(j==0 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==5 || i==10 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==5 || i==10 || i==15) && 
				 (j==0 || j==15)) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro district02
// -----------------------------------------------------------------------------
void MarkRoad_district02() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(j==7 || j==14) Ground[i][j] = SIDEWALK_UP;
			if(j==9 || j==1) Ground[i][j] = SIDEWALK_DOWN;
			if(i==1 || i==14 || j==1) Ground[i][j] = PAWEMENT;
			if(j>8 && i==12) Ground[i][j] = ROAD01_VERT;
			if(j==0 || j==8 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==15) && (j==0 || j==8 || j==15)) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro district03
// -----------------------------------------------------------------------------
void MarkRoad_district03() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(i==1 || i==14 || j==1 || j==7 || j== 9 || j==14) Ground[i][j] = PAWEMENT;
			if(j==0 || j==8 || j==15) Ground[i][j] = ROAD02_HORIZ;
			if(i==0 || i==15) Ground[i][j] = ROAD02_VERT;
			if((i==0 || i==15) && (j==0 || j==8 || j==15)) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro suburb00
// -----------------------------------------------------------------------------
void MarkRoad_suburb00() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if(j==4 || j==11) Ground[i][j] = ROAD02_HORIZ;
			if(j==5 || j==12) Ground[i][j] = SIDEWALK_DOWN;
			if(j==3 || j==10) Ground[i][j] = SIDEWALK_UP;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro suburb01
// -----------------------------------------------------------------------------
void MarkRoad_suburb01() {
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;						
			if(j==5 || j==12) Ground[i][j] = SIDEWALK_DOWN;
			if(j==3 || j==10) Ground[i][j] = SIDEWALK_UP;
			if(i==4 || i==11) Ground[i][j] = ROAD01_VERT;
			if(j==4 || j==11) Ground[i][j] = ROAD02_HORIZ;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro suburb02
// -----------------------------------------------------------------------------
void MarkRoad_suburb02() {
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;						
			if(i==4 || i==11) Ground[i][j] = ROAD01_VERT;
			if(j==8) Ground[i][j] = ROAD01_HORIZ;
			if((i==4 || i==11) && (j==8)) Ground[i][j] = ROAD01_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro suburb03
// -----------------------------------------------------------------------------
void MarkRoad_suburb03() {
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = GRASS;
			if((j==2 && i==8) ||
				 (j==3 && i==7) ||
				 (j==4 && i==6) ||
				 (j==5 && i==5) ||
				 (j==6 && i==4) ||
				 (j==7 && i==3) ||
				 (j==8 && i==2) ) Ground[i][j] = PAWEMENT_45R_L;
			if((j==3 && i==8) || 
				 (j==4 && i==7) ||
				 (j==5 && i==6) ||
				 (j==6 && i==5) ||
				 (j==7 && i==4) ||
				 (j==8 && i==3) ) Ground[i][j] = ROAD02_45L_L;
			if((j==4 && i==8) ||
				 (j==5 && i==7) ||
				 (j==6 && i==6) ||
				 (j==7 && i==5) ||
				 (j==8 && i==4) || 
				 (j==9 && i==3) ) Ground[i][j] = ROAD02_45L_M;
			if((j==4 && i==9) ||
				 (j==5 && i==8) ||
				 (j==6 && i==7) ||
				 (j==7 && i==6) ||
				 (j==8 && i==5) || 
				 (j==9 && i==4) )  Ground[i][j] = ROAD02_45L_R;
			if((j==4 && i==10) ||
				 (j==5 && i==9) ||
				 (j==6 && i==8) ||
				 (j==7 && i==7) ||
				 (j==8 && i==6) || 
				 (j==9 && i==5) ) Ground[i][j] = PAWEMENT_45R_R;

			if((j== 9 && (i<4 || i>10)) ||
				 (j==11 && (i<4 || i>10)) ||
				 (i==4 && j>9) ||
				 (i==2 && j>11) ||
				 (i==9 || i==11)) Ground[i][j] = PAWEMENT;
			if(j==10 && (i<4 || i>10)) Ground[i][j] = ROAD02_HORIZ;
			if((i==3 && j>9) || i==10) Ground[i][j] = ROAD02_VERT;
			if(i==3 && j==9) Ground[i][j] = ROAD02_CROSS_45L31;
			if(i==4 && j==9) Ground[i][j] = ROAD02_CROSS_45L32;
			if(i==9 && j==3) Ground[i][j] = ROAD02_CROSS_45R41;
			if(i==9 && j==4) Ground[i][j] = ROAD02_CROSS_45R42;
			if(i==10 && j==3) Ground[i][j] = ROAD02_CROSS;
			if(i==3 && j==10) Ground[i][j] = ROAD02_CROSS;
			if(i==10 && j==10) Ground[i][j] = ROAD02_CROSS;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro RandomTownStructure
// -----------------------------------------------------------------------------
void MarkRoad_RandomTownStructure() {	
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) {
			Ground[i][j] = OnRandomGround(i,j);
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vyznaci silnici pro danou strukturu
// -----------------------------------------------------------------------------
void MarkRoad(int IPs) {

	// init pole
	for(int i=0;i<=MAX_G;i++)
		for(int j=0;j<=MAX_G;j++) 
			Ground[i][j] = GRASS;

	// oznaceni silnic podle prislusne struktury
		switch(IPs) {
			case  0: MarkRoad_centre00(); break;
			case  1: MarkRoad_centre01(); break;
			case  2: MarkRoad_centre02(); break;
			case  3: MarkRoad_centre03(); break;

		  case  4: MarkRoad_district00(); break;
			case  5: MarkRoad_district01(); break;
			case  6: MarkRoad_district02(); break;
			case  7: MarkRoad_district03(); break;

			case  8: MarkRoad_square00(); break;
			case  9: MarkRoad_square01(); break;
			case 10: MarkRoad_square02(); break;
			case 11: MarkRoad_square03(); break;

			case 12: MarkRoad_suburb00(); break;
			case 13: MarkRoad_suburb01(); break;
			case 14: MarkRoad_suburb02(); break;
			case 15: MarkRoad_suburb03(); break;

			case 16: MarkRoad_RandomTownStructure(); break;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vraci index co mam byt na povrchu
// 0 - trava
// 1 - trava s chodnikem
// 2 - silnice s chodniky - jednosmerna
// 3 - silnice - obousmerna
// ........
// -----------------------------------------------------------------------------
GROUND OnGround(int x, int y) {
	return Ground[x][y];
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru road.cpp
// =============================================================================