// =============================================================================
// soubor GenTownFlat.cpp
// =============================================================================

#include "GenTownFlat.h"

const int MAX = 3;
int TownStructures[MAX][MAX];
TOWN_STRUCTURE IPs_LU_corner,IPs_RU_corner,IPs_LD_corner,IPs_RD_corner;


// -----------------------------------------------------------------------------
// kontrola pole TownStructures[i][j]
// -----------------------------------------------------------------------------
void kontrola() {

		printf("\n");
		printf("\n");
	for(int i=0;i<MAX;i++) {
		for(int j=0;j<MAX;j++) {		
			printf("%d ",TownStructures[i][j]);
	}
	printf("\n");
	}
		printf("\n");
		printf("\n");
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.kontrola rohu
// -----------------------------------------------------------------------------
void WriteCorner(int IPs) {
	switch(IPs) {
		case  0: printf(" CENTRE "); break;
		case  1: printf(" DISTRICT "); break;
		case  2: printf(" SQUARE "); break; 
		case  3: printf(" SUBURB "); break;
	}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vybere pseudonahodne (rand()) mestskou strukturu 0..15
// -----------------------------------------------------------------------------
int RandTownStructure() {

	int r,max;
	max = RAND_MAX;	
  //srand(time(NULL));
	r=rand();

	return(r%15);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.pomoc pro vypsani dane mestke struktury
// -----------------------------------------------------------------------------
void WriteStructure(int IPs) {
	switch(IPs) {
		case  0: printf("centre00"); break;
		case  1: printf("centre01"); break;
		case  2: printf("centre02"); break; 
		case  3: printf("centre03"); break;

		case  4: printf("district00"); break;
		case  5: printf("district01"); break;
		case  6: printf("district02"); break; 
		case  7: printf("district03"); break;

		case  8: printf("square00"); break;
		case  9: printf("square01"); break;
		case 10: printf("square02"); break; 
		case 11: printf("square03"); break;

		case 12: printf("suburb00"); break;
		case 13: printf("suburb01"); break;
		case 14: printf("suburb02"); break; 
		case 15: printf("suburb03"); break;
		}
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. oznaci jaky typ mestske struktury se nachazi v prislusnem 'rohu mesta'
// -----------------------------------------------------------------------------
TOWN_STRUCTURE MarkCorner(int c) {
	c = 15-c;
	TOWN_STRUCTURE corner;
  if(c<4)  corner = SUBURB; else
	if(c<8)  corner = SQUARE; else
	if(c<12) corner = DISTRICT; else
		       corner = CENTRE;
  return (corner);	
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vybere mestskou strukturu centrum bez centre02,03
// -----------------------------------------------------------------------------
int SelectCentreTown(int c) {
	c = c%2;
	int TownStructure;
	switch(c) {
		case  0: TownStructure = 0; break;
		case  1: TownStructure = 1; break;
	}
	return(TownStructure);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vybere mestskou strukturu centrum bez centre00,01
// -----------------------------------------------------------------------------
int SelectCentre(int c) {
	c = c%2;
	int TownStructure;
	switch(c) {
		case  0: TownStructure = 2; break;
		case  1: TownStructure = 3; break;
	}
	return(TownStructure);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vybere mestskou strukturu ze ctvrti
// -----------------------------------------------------------------------------
int SelectDistrict(int c) {
	c = c%4;
	int TownStructure;
	switch(c) {
		case  0: TownStructure = 4; break;
		case  1: TownStructure = 5; break;
		case  2: TownStructure = 6; break;
		case  3: TownStructure = 7; break;
	}
	return(TownStructure);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vybere mestskou strukturu namesti bez square00,01 45stupnove silnice
// -----------------------------------------------------------------------------
int SelectSquare(int c) {
	c = c%2;
	int TownStructure;
	switch(c) {
		case  0: TownStructure = 10; break;
		case  1: TownStructure = 11; break;
	}
	return(TownStructure);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. vybere mestskou strukturu z predmesti
// -----------------------------------------------------------------------------
int SelectSuburb(int c) {
	c = c%4;
	int TownStructure;
	switch(c) {
		case  0: TownStructure = 12; break;
		case  1: TownStructure = 13; break;
		case  2: TownStructure = 14; break;
		case  3: TownStructure = 15; break;
	}
	return(TownStructure);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. pro neopakujici vyber mestskych struktur zjisti 
// z kterych mestskych struktur jeste muze vybirat
// -----------------------------------------------------------------------------
int SelectFrom3(int c) {
	int pom_c = c;
	c = c%3;
	int TownStructure;
	switch(IPs_LU_corner) {
		case CENTRE: 	
			switch(c) {
				case 0: TownStructure = SelectDistrict(pom_c); break;
				case 1: TownStructure = SelectSquare(pom_c); break;
				case 2: TownStructure = SelectSuburb(pom_c); break;
			} 
		break;
		case DISTRICT: 	
			switch(c) {
				case 0: TownStructure = SelectCentre(pom_c); break;
				case 1: TownStructure = SelectSquare(pom_c); break;
				case 2: TownStructure = SelectSuburb(pom_c); break;
			} 
		break;
		case SQUARE: 	
			switch(c) {
				case 0: TownStructure = SelectCentre(pom_c); break;
				case 1: TownStructure = SelectDistrict(pom_c); break;
				case 2: TownStructure = SelectSuburb(pom_c); break;
			} 
		break;
		case SUBURB: 	
			switch(c) {
				case 0: TownStructure = SelectCentre(pom_c); break;
				case 1: TownStructure = SelectDistrict(pom_c); break;
				case 2: TownStructure = SelectSquare(pom_c); break;
			} 
		break;
    default: TownStructure=-1; exit(0); break;
	}
  return (TownStructure);	
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. pro neopakujici vyber mestskych struktur zjisti 
// z kterych mestskych struktur jeste muze vybirat
// -----------------------------------------------------------------------------
int SelectFrom2(int c) {
	int pom_c = c;
	c = c%2;
	int TownStructure;
  if((IPs_LU_corner == CENTRE || IPs_RU_corner == CENTRE) && 
		 (IPs_LU_corner == DISTRICT ||IPs_RU_corner == DISTRICT) )
		if(c == 0) TownStructure = SelectSquare(pom_c); 
		else TownStructure = SelectSuburb(pom_c);
	else
  if((IPs_LU_corner == CENTRE || IPs_RU_corner == CENTRE) && 
		 (IPs_LU_corner == SQUARE ||IPs_RU_corner == SQUARE) )
		if(c == 0) TownStructure = SelectDistrict(pom_c);
		else TownStructure = SelectSuburb(pom_c);
	else
  if((IPs_LU_corner == CENTRE || IPs_RU_corner == CENTRE) && 
		 (IPs_LU_corner == SUBURB ||IPs_RU_corner == SUBURB) )
		if(c == 0) TownStructure = SelectDistrict(pom_c);
		else TownStructure = SelectSquare(pom_c);
	else
  if((IPs_LU_corner == DISTRICT || IPs_RU_corner == DISTRICT) && 
		 (IPs_LU_corner == SQUARE ||IPs_RU_corner == SQUARE) )
		if(c == 0) TownStructure = SelectCentre(pom_c);
		else TownStructure = SelectSuburb(pom_c);
	else
  if((IPs_LU_corner == DISTRICT || IPs_RU_corner == DISTRICT) && 
		 (IPs_LU_corner == SUBURB ||IPs_RU_corner == SUBURB) )
		if(c == 0) TownStructure = SelectCentre(pom_c);
		else TownStructure = SelectSquare(pom_c);
	else
  if((IPs_LU_corner == SQUARE || IPs_RU_corner == SQUARE) && 
		 (IPs_LU_corner == SUBURB ||IPs_RU_corner == SUBURB) )
		if(c == 0) TownStructure = SelectCentre(pom_c);
		else TownStructure = SelectDistrict(pom_c);
	else { TownStructure = -1;  exit(0); }  // chyba
	
  return (TownStructure);	
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce. pro neopakujici vyber mestskych struktur zjisti 
// z kterych mestskych struktur jeste muze vybirat
// -----------------------------------------------------------------------------
int SelectFrom1(int c) {
	int pom_c = c;
	int TownStructure;
	if((IPs_LU_corner == CENTRE || IPs_RU_corner == CENTRE || IPs_LD_corner == CENTRE) &&
		 (IPs_LU_corner == DISTRICT || IPs_RU_corner == DISTRICT || IPs_LD_corner == DISTRICT) &&
		 (IPs_LU_corner == SQUARE || IPs_RU_corner == SQUARE || IPs_LD_corner == SQUARE) )
    TownStructure = SelectSuburb(pom_c); else
	if((IPs_LU_corner == CENTRE || IPs_RU_corner == CENTRE || IPs_LD_corner == CENTRE) &&
		 (IPs_LU_corner == SQUARE || IPs_RU_corner == SQUARE || IPs_LD_corner == SQUARE) &&
		 (IPs_LU_corner == SUBURB || IPs_RU_corner == SUBURB || IPs_LD_corner == SUBURB) )
    TownStructure = SelectDistrict(pom_c); else
	if((IPs_LU_corner == CENTRE || IPs_RU_corner == CENTRE || IPs_LD_corner == CENTRE) &&
		 (IPs_LU_corner == DISTRICT || IPs_RU_corner == DISTRICT || IPs_LD_corner == DISTRICT) &&
		 (IPs_LU_corner == SUBURB || IPs_RU_corner == SUBURB || IPs_LD_corner == SUBURB) )
    TownStructure = SelectSquare(pom_c); else
	if((IPs_LU_corner == DISTRICT || IPs_RU_corner == DISTRICT || IPs_LD_corner == DISTRICT) &&
		 (IPs_LU_corner == SQUARE || IPs_RU_corner == SQUARE || IPs_LD_corner == SQUARE) &&
		 (IPs_LU_corner == SUBURB || IPs_RU_corner == SUBURB || IPs_LD_corner == SUBURB) )
    TownStructure = SelectCentre(pom_c); else
	{ TownStructure = -1;  exit(0); }  // chyba

	return(TownStructure);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.CreateGenTownFlat vygenereuje mesto se silnicemi 2D
// -----------------------------------------------------------------------------
SoSeparator *GenTownFlat() {

  SoSeparator *TownFlat = new SoSeparator;
  TownFlat -> ref();

	int i,j,k, InTown;
	float x,z;
  int IPs=0;
	extern int IPs_L,IPs_R,IPs_D,IPs_U;
	IPs_L=IPs_R=IPs_D=IPs_U=0;
	x=z=0.0f;
	k=0;
	InTown=0;//RandTownStructure();
	printf("\n");

/*
	for(int p=0; p<15; p++) {
		IPs=RandTownStructure();
		printf(" %d ", IPs);
	}
	exit(0);
*/

	for(i=0;i<MAX;i++) 
		for(j=0;j<MAX;j++) {
			TownStructures[i][j] = 0;
	}

	//kontrola();

	// vygeneruji z jakych struktur se bude skladat mesto a ulozim si je
	printf("  Mesto obsahuje pripravne mestske struktury: \n\n");
	for(i=0;i<MAX;i++) { 
		for(j=0;j<MAX;j++) {
			
			if(k == 1) { IPs = 16; k=0; }				
			else       { k=1; InTown++; //if(pom==0) pom=15; pom--; IPs=pom; 

				IPs=RandTownStructure()+InTown;
				if(IPs>15) IPs-=15;
				switch(InTown) {
					// LEFT UP
					case 1: 
						printf("    Levy horni roh  - ");
						if(IPs==8 || IPs==9) IPs+=2;
						IPs_LU_corner = MarkCorner(IPs);
						WriteStructure(IPs);
						printf("\n");
					break;
					// RIGHT UP
					case 2:	
						printf("    Pravy horni roh - ");
						IPs = SelectFrom3(IPs);
						IPs_RU_corner = MarkCorner(IPs);
						WriteStructure(IPs); 
						printf("\n");
					break;
					// CENTRE
					case 3:	
						printf("    Ve stredu mesta - "); 
						IPs = SelectCentreTown(IPs);
						WriteStructure(IPs); 
						printf("\n");
					break; 
					// LEFT DOWN
					case 4:	
						printf("    Levy dolni roh  - ");
						IPs = SelectFrom2(IPs);
						IPs_LD_corner = MarkCorner(IPs);
						WriteStructure(IPs); 
						printf("\n");
					break;
					// LEFT UP
					case 5:	
						printf("    Pravy dolni roh - ");
						IPs = SelectFrom1(IPs);
						IPs_RD_corner = MarkCorner(IPs);
						WriteStructure(IPs); 
						printf("\n");
					break;
				}
						
			}
			
			TownStructures[i][j] = IPs;
		}
		if(MAX%2==0) 
			if(k==0) k=1;
			else k=0;
			
	}

  //kontrola();

	// generuji struktury za strukturou(mesto) tady jiz zna kazdy sveho souseda
	for(i=0;i<MAX;i++) {
		for(j=0;j<MAX;j++) {
			//
		  IPs = TownStructures[i][j];
			// nahodna -> zjisti sousedy(pro vygen.cest), uloz, predej
			if(IPs==16) {
				if(j==0) IPs_L = -1; 
				else IPs_L = TownStructures[i][j-1];
				if(j==(MAX-1)) IPs_R = -1; 
				else IPs_R = TownStructures[i][j+1];
				if(i==0) IPs_U = -1; 
				else IPs_U = TownStructures[i-1][j];
				if(i==(MAX-1)) IPs_D = -1; 
				else IPs_D = TownStructures[i+1][j];
				//printf("\n\t %d %d %d %d",IPs_L,IPs_R,IPs_U,IPs_D);
			}
		  TownFlat -> addChild(MakeTownStructure(IPs,x,0,z,0,COLOR));		
			x+=MAX_GROUND+2.0;			
		}
		x=0.0f;
		z+=MAX_GROUND+2.0;
	}

  //kontrola();
/*
	printf("\n");
	WriteCorner(IPs_LU_corner);
	WriteCorner(IPs_RU_corner);
	WriteCorner(IPs_LD_corner);
	WriteCorner(IPs_RD_corner);
	printf("\n");
*/
	return TownFlat;		
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.TownFlatEvent - obsluha klavesnice
// -----------------------------------------------------------------------------
void TownFlatEventCB(void * userData, SoEventCallback * node) {

	SoSeparator * root = (SoSeparator*)userData;
	const SoEvent * event = node->getEvent();

	// obsluha pro - SPACE mezernik - opetovne generovani mesta
	if( SoKeyboardEvent::isKeyPressEvent(event,SoKeyboardEvent::SPACE) ) {
	  root -> removeAllChildren();
		printf("\n\n\t Generuji virtualni mestskou cekejte prosim. \n");
	  root -> addChild(GenTownFlat());
  }

	node->setHandled();
} 
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.CreateGenTownFlat vygenereuje mesto se silnicemi 2D
// -----------------------------------------------------------------------------
SoSeparator *CreateGenTownFlat(int argc, char **argv) {
  return GenTownFlat();
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru GenTownFlat.cpp
// =============================================================================