// =============================================================================
// soubor FaultFormation2.h
// =============================================================================

#ifndef FaultFormation2_h_
#define FaultFormation2_h_

#include <Inventor/SbLinear.h>
#include <assert.h>

#include <Inventor/nodes/SoEventCallback.h> 
#include <Inventor/events/SoKeyboardEvent.h>  

class SoSeparator;


// ***************************************************************************** 
// my code 
// *****************************************************************************
typedef struct PI03height_level{
  float water;
  float mountains;
  float snow;
} PI03HEIGHT_LEVEL;
// *****************************************************************************


/*!
  Tda pedstavujc tverec v krajin.
*/
class PI03TerrainPatch {
private:
  float minHeight, maxHeight;
  void allocHMap(unsigned int w, unsigned int h);
  void freeHMap();
  void filter(float k);
  SbVec3f calculateNormal(const unsigned int x, const unsigned int y, const float sx, const float sy);

public:


// *****************************************************************************
// my code 
// *****************************************************************************

   PI03HEIGHT_LEVEL PI03level;

// *****************************************************************************


  float *HMap;
  unsigned int HMapWidth;
  unsigned int HMapHeight;
  float wsize;
  float hsize;

  inline int getHmapIndex(const int x, const int y);
  int getMaterialIndex(const float height, const float minHeight, const float maxHeight);

public:
  PI03TerrainPatch();
  ~PI03TerrainPatch();

  void generateHeightMap();
  void generateHeightMap(int hmapWidth, int hmapHeight, int NumIter,
                         float MaxDelta, float MinDelta, float FilterValue,
						 float wsize, float hsize);


// *****************************************************************************
// my code 
// *****************************************************************************

  int getIndex_x(float x) { return int(x); }
  int getIndex_y(float y) { return int(y); }

  float getHeight(float x, float y){ 
    int index_x = int((x/wsize) * HMapWidth + 0.5f);
    int index_y = int((y/hsize) * HMapHeight + 0.5f);
	// hlida pole vysek 
    assert(index_x >= 0 && index_y >= 0 && 
		   index_x < (int)HMapWidth && index_y < (int)HMapHeight &&
           "Wrong Hmap index.");
    return HMap[getHmapIndex(index_x,index_y)];
  } 
  void getLeveL(float wsize, float hsize, int hq);

// *****************************************************************************

	SoSeparator* GenerTerrainTown(int argc, char **argv);

  SoSeparator* getModel();
  SoSeparator* getModel(float wsize, float hsize, int hq);

  static SoSeparator* generate();
  static SoSeparator* generate(int hmapWidth, int hmapHeight, float wsize,
                               float hsize, int NumIter, float MaxDelta,
                               float MinDelta, float FilterValue, int hq);

  void reset();
};


#endif /*FaultFormation2_h_*/

// =============================================================================
// konec souboru FaultFormation2.h
// =============================================================================