// =============================================================================
// soubor GenTownTerrain.cpp
// =============================================================================

#include "GenTownTerrain.h"

#define PI03MAX_X 128.f
#define PI03MAX_Z 128.f
#define PI03MAX_SUBURB 30.5f
#define PI03MAX_SUBURB_SQUARE 15.f
#define PI03MAX_CENTRE 13.5f
#define PI03MAX_CENTRE_SQUARE 6.5f
#define PI03RASTR 0.5f
#define PI03MAX_BUILDING 34

// pomocne prom pro hledani vhodnych lokalit na mape
bool PI03round;
float PI03x_min;
float PI03z_min;
float PI03control_x,PI03pom_x;
int PI03count_round;
TEXTURE mat = BRICK;

PI03POSITION PI03suburb, 
						 PI03centre, 
						 PI03between_streets, 
						 PI03around_streets_in, 
						 PI03around_streets_out;


// -----------------------------------------------------------------------------
// postavi budovu na mapu
// -----------------------------------------------------------------------------
SoSeparator* PI03put_building(PI03TerrainPatch *tp,int building, float x, float z, float alfa) {

  SoSeparator* Building = new SoSeparator;
	
  float offset=0.f;
  float zoom=1.f;
  float x1=0.f;
  float x2=0.f;
  float z1=0.f;
  float z2=0.f;	


  x1=x-zoom*GetParamBuilding(building,1);
  z1=z-zoom*GetParamBuilding(building,2);
  x2=x+zoom*GetParamBuilding(building,1);
  z2=z+zoom*GetParamBuilding(building,2);

  if(tp->getHeight(x,z) > tp->PI03level.water && 
	 tp->getHeight(x,z) < tp->PI03level.mountains) {

     float pos_x = x;
     float pos_z = z;
     float pos_y = PI03modif( tp, 
                   tp->getIndex_x(x1-offset), tp->getIndex_y(z1-offset), 
	                 tp->getIndex_x(x2+offset), tp->getIndex_y(z2+offset), 
	                 alfa);

     Building -> addChild(MakeBuilding(building, 
                          pos_x, pos_y, pos_z, 
		                      PI03degree_to_radian(-alfa),
													mat));

		 mat = NextTexture(mat);

	 }

  return(Building);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.zjistuje zda dana oblast lezi(ve vhodne lok.) nad vodou a zaroven pod skaly
// -----------------------------------------------------------------------------
bool PI03is_OK_area(PI03TerrainPatch *tp,float max) {

  bool area=true;
  float x,z; 
  float xs=PI03RASTR;
  float zs=PI03RASTR;
	float offset =15.f;
  
  x=PI03x_min;
  z=PI03z_min;

  if(PI03x_min+max>PI03MAX_X) 
	area=false;
 
  while((x+offset)<PI03x_min+max && PI03x_min+max<=(PI03MAX_X-offset) && area) {
	if(PI03control_x==x && PI03count_round==1) {
	  PI03round=true;
	  area=false;
    }
    while((z+offset)<PI03z_min+max && PI03z_min+max<=(PI03MAX_Z-offset) && area) {
	  if(tp->getHeight(x,z) < tp->PI03level.water || 
		   tp->getHeight(x,z) > tp->PI03level.mountains) {
		area=false;
        PI03z_min=z+zs;
		}
	  else
    z+=zs;
	} // end while z
	z=PI03z_min;
    x+=xs;
  } // end while x
  x=0.f;
  if(PI03x_min+max>PI03MAX_X) {
	PI03count_round++;
	PI03x_min=0.f;
    PI03z_min=0.f;
  }
  if(PI03z_min+max>PI03MAX_Z) {
	PI03x_min+=xs;
	PI03z_min=0.f;
  }
  PI03pom_x=PI03x_min;

  return area;
}
// -----------------------------------------------------------------------------



// -----------------------------------------------------------------------------
// funkce prochazi mapu a snazi se nalezt vhodnou lokalitu pro centrum
// -----------------------------------------------------------------------------
bool PI03find_suburb(PI03TerrainPatch *tp,float maxx) {
  bool found=false;

  PI03round=false;
  PI03control_x=PI03x_min;
  PI03count_round=-1;

  PI03pom_x=0.f;

  while(!found && !PI03round) {
	if(PI03is_OK_area(tp,maxx)) {
	  found=true;
  	PI03suburb.x_min=PI03x_min;
	  PI03suburb.z_min=PI03z_min;
	  PI03suburb.x_max=PI03x_min+maxx;
	  PI03suburb.z_max=PI03z_min+maxx;       
	}
  }

  return found;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vytvori mestske centrum v kruhove formaci
// -----------------------------------------------------------------------------
SoSeparator* PI03create_suburb(PI03TerrainPatch *tp) {

  SoSeparator* Suburb = new SoSeparator;

  float alfa=45;
  int building=13;
  int end=5;
  float x=0;
  float z=0;
  float r=5;
  float center_x=PI03suburb.x_min+(PI03suburb.x_max-PI03suburb.x_min)/2.f;
  float center_z=PI03suburb.z_min+(PI03suburb.z_max-PI03suburb.z_min)/2.f;

  while(r<PI03suburb.x_max-PI03suburb.x_min) {
	for(int i=1;i<end;i++) {

	  building++;
      
	  switch(i){
	    case 1: x=center_x-r; z=center_z-r; break;
        case 2: x=center_x-r; z=center_z+r; break; 
        case 3: x=center_x+r; z=center_z-r; break;
        case 4: x=center_x+r; z=center_z+r; break;

	    case 5: x=center_x-r; z=center_z; break;
        case 6: x=center_x; z=center_z-r; break; 
        case 7: x=center_x+r; z=center_z; break;
        case 8: x=center_x; z=center_z+r; break;

	    case  9: x=center_x-r; z=center_z-r/2; break;
        case 10: x=center_x-r/2; z=center_z+r; break; 
        case 11: x=center_x+r; z=center_z-r/2; break;
        case 12: x=center_x+r/2; z=center_z+r; break;

	    case 13: x=center_x-r/2; z=center_z-r; break;
        case 14: x=center_x-r; z=center_z+r/2; break; 
        case 15: x=center_x+r/2; z=center_z-r; break;
        case 16: x=center_x+r; z=center_z+r/2; break;
      }


	  switch(end) {
		case 13: 
		  building = SelectBuilding(BY_DOWN_MIN,building,0.5f,-1.0f,0.5f);
		break;


	  }

      alfa+=10;
	  if(alfa>80) alfa = 0;

	  if(x>PI03suburb.x_min && x<PI03suburb.x_max && z>PI03suburb.z_min && z<PI03suburb.z_max)
          Suburb -> addChild(PI03put_building(tp,building,x,z,alfa));
    }
	if(end==17) end=17;
	else end+=4;

    if(end==5) r+=3.f;
	else r+=5.f;
   
  } 

  return(Suburb);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// funkce prochazi mapu a snazi se nalezt vhodnou lokalitu pro centrum
// -----------------------------------------------------------------------------
bool PI03find_centre(PI03TerrainPatch *tp, float maxx) {
  bool found=false;

  PI03round=false;
  PI03control_x=PI03x_min;
  PI03count_round=-1;

  PI03pom_x=0.f;

  while(!found && !PI03round) {
	if(PI03is_OK_area(tp,maxx)) {
	  found=true;
  	PI03centre.x_min=PI03x_min;
	  PI03centre.z_min=PI03z_min;
	  PI03centre.x_max=PI03x_min+maxx;
	  PI03centre.z_max=PI03z_min+maxx;       
	}
  }
  if(PI03centre.x_max>PI03suburb.x_min && 
     PI03centre.z_max>PI03suburb.z_min &&
     PI03centre.x_min<PI03suburb.x_max && 
     PI03centre.z_min<PI03suburb.z_max)
     found=false;

  return found;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vytvori mestske centrum v kruhove formaci
// -----------------------------------------------------------------------------
SoSeparator* PI03create_centre(PI03TerrainPatch *tp,PI03POSITION PI03centre) {

  SoSeparator* Centre = new SoSeparator;

  float alfa=45;
  int building=0;
  int end=5;
  float x=0;
  float z=0;
  float r=1.5;
  float center_x=PI03centre.x_min+(PI03centre.x_max-PI03centre.x_min)/2.f;
  float center_z=PI03centre.z_min+(PI03centre.z_max-PI03centre.z_min)/2.f;

  while(r<PI03centre.x_max-PI03centre.x_min) {
	for(int i=1;i<end;i++) {

	  //building = select_building_by_max_down(building,0.5f,0.5f);
      
	  switch(i){
	    case 1: x=center_x-r; z=center_z-r; break;
        case 2: x=center_x-r; z=center_z+r; break; 
        case 3: x=center_x+r; z=center_z-r; break;
        case 4: x=center_x+r; z=center_z+r; break;

	    case 5: x=center_x-r; z=center_z; break;
        case 6: x=center_x; z=center_z-r; break; 
        case 7: x=center_x+r; z=center_z; break;
        case 8: x=center_x; z=center_z+r; break;

	    case  9: x=center_x-r; z=center_z-r/2; break;
        case 10: x=center_x-r/2; z=center_z+r; break; 
        case 11: x=center_x+r; z=center_z-r/2; break;
        case 12: x=center_x+r/2; z=center_z+r; break;

	    case 13: x=center_x-r/2; z=center_z-r; break;
        case 14: x=center_x-r; z=center_z+r/2; break; 
        case 15: x=center_x+r/2; z=center_z-r; break;
        case 16: x=center_x+r; z=center_z+r/2; break;
      }


	  switch(end) {
	    case 5: 
		  building = SelectBuilding(BY_DMAX_HMIN,building,0.5f,3.f,0.5f);
		break;

		case 9: 
		 building = SelectBuilding(BY_DMAX_HMIN,building,0.5f,2.f,0.5f);
		break;

		case 13:
		  building = SelectBuilding(BY_DMAX_HMAX,building,0.5f,2.f,0.5f);
		break;

	  }

      alfa+=10;
	  if(alfa>80) alfa = 0;

	  if(x>PI03centre.x_min && x<PI03centre.x_max && 
		 z>PI03centre.z_min && z<PI03centre.z_max)
          Centre -> addChild(PI03put_building(tp,building,x,z,alfa));
    }
	if(end==17) end=17;
	else end+=4;

    if(end==5) r+=2.f;
	else r+=2.f;
    
  } 

  return(Centre);
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vytvori zastavbu mezi mestskym centrum a ctvrti
// -----------------------------------------------------------------------------
SoSeparator* PI03create_between_streets(PI03TerrainPatch *tp,PI03POSITION PI03between_streets) {

  SoSeparator* Between_streets = new SoSeparator;

  int x1=(int)PI03between_streets.x_min;
  int z1=(int)PI03between_streets.z_min;
  int x2=(int)PI03between_streets.x_max;
  int z2=(int)PI03between_streets.z_max;

  int building=0;
  int count_building=0;
  float bs_alfa = 0.f;
  bool is_in_suburb=true;
  bool is_in_centre=true;
  bool is_in_between=true;

  for(int x=x1; x<x2; x+=3)
	for(int z=z1; z<z2 ; z+=3) {

	  if(x>PI03centre.x_min && x<PI03centre.x_max && 
		 z>PI03centre.z_min && z<PI03centre.z_max)
         is_in_centre=true;
	  else
		 is_in_centre=false;

	  if(x>PI03suburb.x_min && x<PI03suburb.x_max && 
		 z>PI03suburb.z_min && z<PI03suburb.z_max)
         is_in_suburb=true;
      else
		 is_in_suburb=false;

      if(x>PI03between_streets.x_min && x<PI03between_streets.x_max && 
	     z>PI03between_streets.z_min && z<PI03between_streets.z_max)
		 is_in_between=true;
	  else
		 is_in_between=false;

	  if(is_in_between && !is_in_centre && !is_in_suburb) {
         Between_streets -> addChild(PI03put_building(tp,building,(float)x,(float)z,bs_alfa));
	  }

	  building++;
	  bs_alfa +=20.f;
	  if(bs_alfa>80) bs_alfa = 10.f;

	}


  return(Between_streets);

}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.vytvori zastavbu mezi mestskym centrum a ctvrti
// -----------------------------------------------------------------------------
SoSeparator* PI03create_aPI03round_streets(PI03TerrainPatch *tp,
						 PI03POSITION PI03around_streets_in,PI03POSITION PI03around_streets_out) {

  SoSeparator* API03round_streets = new SoSeparator;

  int x1=(int)PI03around_streets_out.x_min;
  int z1=(int)PI03around_streets_out.z_min;
  int x2=(int)PI03around_streets_out.x_max;
  int z2=(int)PI03around_streets_out.z_max;

  int building=0;
  int count_building=0;
  float as_alfa = 0.f;
  float r;
  float sx=(x2-x1)/2.f;
  float sz=(z2-z1)/2.f;
  float lx;
  float lz;
  if(x2-x1 <= z2-z1) r=(x2-x1)/2.f;
  else r=(z2-z1)/2.f;
  int zs;

  for(int x=x1; x<x2; x+=zs)
	for(int z=z1; z<z2 ; z+=zs) {

	  if(x<=sx) lx=sx-x;
	  else lx=x-sx;

	  if(z<=sz) lz=sz-z;
	  else lz=z-sx;

	  if(!(x>PI03around_streets_in.x_min && x<PI03around_streets_in.x_max && 
		   z>PI03around_streets_in.z_min && z<PI03around_streets_in.z_max) &&		  
		  (x>PI03around_streets_out.x_min && x<PI03around_streets_out.x_max && 
		   z>PI03around_streets_out.z_min && z<PI03around_streets_out.z_max))
		   if(x>sx-10 || x<sx+10 || z>sz-10 || z<sz+10 ) {
             // vykarajuji stredy mensi kruznici
             if( (lx*lx) + (lz*lz) < (r*r)-400.f )
           
		 API03round_streets -> addChild(PI03put_building(tp,building,(float)x,(float)z,as_alfa));

		   }
		   
           else { 
		     // zaobluji rohy vetsi krouznici
		     if( (lx*lx) + (lz*lz) < (r*r) )

          API03round_streets -> addChild(PI03put_building(tp,building,(float)x,(float)z,as_alfa));

		   }

	  zs=(int)GetParamBuilding(building,2)+6;
	  building = SelectBuilding(BY_DMAX_HMAX,building,4.f,1.5f,4.f);;
	  //if(count_building==2) { count_building=0; bs_alfa +=30.f;}
	  as_alfa +=20.f;
	  if(as_alfa>80) as_alfa = 10.f;
	}

  return(API03round_streets);

}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// fce.generuje virtualni mestskou zastavbu
// -----------------------------------------------------------------------------
SoSeparator* PI03GenerTown(PI03TerrainPatch *tp) {

  // uzel do ktereho se generuje mesto
  SoSeparator* town = new SoSeparator;

  // pozice od ktere se hleda lokalita pro umisteni centra mesta
  PI03x_min=PI03MAX_X/2;
  PI03z_min=PI03MAX_Z/2;
  bool f_suburb = false;

  if(PI03find_suburb(tp,PI03MAX_SUBURB)) {

	f_suburb=true;

	// v prostred centra si to vytvorime male namesti
    float high_square_suburb =
    PI03modif( tp, 
           tp->getIndex_x(PI03suburb.x_min + PI03MAX_SUBURB_SQUARE), 
		   tp->getIndex_y(PI03suburb.z_min + PI03MAX_SUBURB_SQUARE), 
	       tp->getIndex_x(PI03suburb.x_max - PI03MAX_SUBURB_SQUARE), 
		   tp->getIndex_y(PI03suburb.z_max - PI03MAX_SUBURB_SQUARE), 
	       0.f);

    town -> addChild(PI03create_suburb(tp));

    printf("Suburb found on position: ");
    printf("%.2f %.2f %.2f %.2f \n",PI03suburb.x_min,PI03suburb.z_min,PI03suburb.x_max,PI03suburb.z_max);
	//printf("high_square_suburb is %f \n",high_square_suburb);
  }
  else 
    printf("Suburb NOT found: \n");



  // pozice od ktere se hleda lokalita pro umisteni ctvrti mesta
  PI03x_min=PI03MAX_X/4;
  PI03z_min=PI03MAX_Z/4;

  bool f_centre =false;

  if(PI03find_centre(tp,PI03MAX_CENTRE)) {

	f_centre =true;

    float high_square_centre = 
	PI03modif( tp, 
           tp->getIndex_x(PI03centre.x_min + PI03MAX_CENTRE_SQUARE), 
		   tp->getIndex_y(PI03centre.z_min + PI03MAX_CENTRE_SQUARE), 
	       tp->getIndex_x(PI03centre.x_max - PI03MAX_CENTRE_SQUARE), 
		   tp->getIndex_y(PI03centre.z_max - PI03MAX_CENTRE_SQUARE), 
	       0.f);

	//printf("high_square_centre is  %f \n",high_square_centre);

    town -> addChild(PI03create_centre(tp,PI03centre));

    printf("Centre found on position: ");
    printf("%.2f %.2f %.2f %.2f \n", PI03centre.x_min, PI03centre.z_min,
		                     PI03centre.x_max, PI03centre.z_max);
	//printf("high_square_centre is %f \n",high_square_centre);
  }
  else 
    printf("Centre NOT found: \n");



  bool f_between_streets=false;

  // vyplneni prostoru mezi centrem a predmestim
  if(f_suburb && f_centre) {

    f_between_streets=true;

    if(PI03suburb.x_min < PI03centre.x_min) PI03between_streets.x_min = PI03suburb.x_min;
    else PI03between_streets.x_min = PI03centre.x_min;

    if(PI03suburb.z_min < PI03centre.z_min) PI03between_streets.z_min = PI03suburb.z_min;
    else PI03between_streets.z_min = PI03centre.z_min;

    if(PI03suburb.x_max > PI03centre.x_max) PI03between_streets.x_max = PI03suburb.x_max;
    else PI03between_streets.x_max = PI03centre.x_max;

    if(PI03suburb.z_max > PI03centre.z_max) PI03between_streets.z_max = PI03suburb.z_max;
    else PI03between_streets.z_max = PI03centre.z_max;

    town -> addChild(PI03create_between_streets(tp,PI03between_streets));

    printf("Between_streets found on position: ");
    printf("%.2f %.2f %.2f %.2f \n", PI03between_streets.x_min, PI03between_streets.z_min,
		                     PI03between_streets.x_max, PI03between_streets.z_max);
  }
  else 
    printf("Between_streets NOT found: \n");

  // vyplneni okoli mesta
  if(f_suburb || f_centre || f_between_streets) {

	 if(f_between_streets) {
	  PI03around_streets_in.x_min = PI03between_streets.x_min;
		PI03around_streets_in.z_min = PI03between_streets.z_min;
		PI03around_streets_in.x_max = PI03between_streets.x_max;
		PI03around_streets_in.z_max = PI03between_streets.z_max;
	 }
	 else if(f_centre) {
	  PI03around_streets_in.x_min = PI03centre.x_min;
		PI03around_streets_in.z_min = PI03centre.z_min;
		PI03around_streets_in.x_max = PI03centre.x_max;
		PI03around_streets_in.z_max = PI03centre.z_max;
     } 
	 else if(f_suburb) {
	  PI03around_streets_in.x_min = PI03suburb.x_min;
		PI03around_streets_in.z_min = PI03suburb.z_min;
		PI03around_streets_in.x_max = PI03suburb.x_max;
		PI03around_streets_in.z_max = PI03suburb.z_max;
	 }

     float aPI03round = 35.f;

	 if(PI03around_streets_in.x_min-aPI03round < 0.f) PI03around_streets_out.x_min=0.f;
	 else PI03around_streets_out.x_min=PI03around_streets_in.x_min-aPI03round;

	 if(PI03around_streets_in.z_min-aPI03round < 0.f) PI03around_streets_out.z_min=0.f;
	 else PI03around_streets_out.z_min=PI03around_streets_in.z_min-aPI03round;

	 if(PI03around_streets_in.x_max+aPI03round > PI03MAX_X) PI03around_streets_out.x_max=PI03MAX_X;
	 else PI03around_streets_out.x_max=PI03around_streets_in.x_max+aPI03round;

	 if(PI03around_streets_in.z_max+aPI03round > PI03MAX_Z) PI03around_streets_out.z_max=PI03MAX_Z;
	 else PI03around_streets_out.z_max=PI03around_streets_in.z_max+aPI03round;

    town -> addChild(PI03create_aPI03round_streets(tp,PI03around_streets_in,PI03around_streets_out));

    printf("Round_streets found on position: \n");
    printf("in: %.2f %.2f %.2f %.2f \n", PI03around_streets_in.x_min, PI03around_streets_in.z_min,
		                         PI03around_streets_in.x_max, PI03around_streets_in.z_max);
    printf("out: %.2f %.2f %.2f %.2f \n", PI03around_streets_out.x_min, PI03around_streets_out.z_min,
		                          PI03around_streets_out.x_max, PI03around_streets_out.z_max);
  }
  else 
    printf("Round_streets NOT found: \n");


  return(town);
}
// -----------------------------------------------------------------------------


// =============================================================================
// konec souboru GenTownTerrain.cpp
// =============================================================================